# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.CQUERY10
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache

from coral.addins.CQUERY10.queryelementeditor import QueryElement

class QueryElementEditor(QueryElement,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QueryElement.__init__(self,parent)
        self.setName("QueryElement")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.AbstractElementEdit.setReadOnly(True)
        self.connect(self.NewElement,SIGNAL('clicked()'),self.NewElementClicked)
        self.connect(self.SelectElement,SIGNAL('clicked()'),self.SelectElementClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QueryElement.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.QueryElement]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.abstractElement
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.AbstractElementEdit.setText("")
        if element.abstractElement:
            self.AbstractElementEdit.setText(getFQName(element.abstractElement,1))
            self.AbstractElementEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectElementClicked(self):
        ed=self.focus.__type__().getPropertyByName("abstractElement").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.abstractElement=r
            self.AbstractElementEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewElementClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("abstractElement")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class QueryElementsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "QueryElements"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Query]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [QueryElementEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "queryelement"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        return L.QueryElement()
    elementFactory = staticmethod(elementFactory)

