# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.CoralEx10
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache

from coral.addins.CoralEx10.DiagramElement import DiagramElementExtUI

class DiagramElementExtEditor(DiagramElementExtUI,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        DiagramElementExtUI.__init__(self,parent)
        self.setName("DiagramElementExt")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ElementKindEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ElementKindEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.RendererEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.RendererEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.LayouterEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.LayouterEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.UIEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.UIEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ProfileEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ProfileEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        DiagramElementExtUI.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Addins.DiagramElementExt]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.ElementKindEdit.setText(unicode(element.element_kind))
        self.ElementKindEdit.setEdited(0)
        
        self.RendererEdit.setText(unicode(element.rendererPath))
        self.RendererEdit.setEdited(0)
        
        self.LayouterEdit.setText(unicode(element.layouterPath))
        self.LayouterEdit.setEdited(0)
        
        self.UIEdit.setText(unicode(element.uiPath))
        self.UIEdit.setEdited(0)
        
        self.ProfileEdit.setText(unicode(element.profile))
        self.ProfileEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.ElementKindEdit.text())
            self.focus.element_kind=t
            self.ElementKindEdit.setEdited(0)
            
            t=unicode(self.RendererEdit.text())
            self.focus.rendererPath=t
            self.RendererEdit.setEdited(0)
            
            t=unicode(self.LayouterEdit.text())
            self.focus.layouterPath=t
            self.LayouterEdit.setEdited(0)
            
            t=unicode(self.UIEdit.text())
            self.focus.uiPath=t
            self.UIEdit.setEdited(0)
            
            t=unicode(self.ProfileEdit.text())
            self.focus.profile=t
            self.ProfileEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

from coral.addins.CoralEx10.SimpleDiagramElement import SimpleDiagramElementExtUI

class SimpleDiagramElementExtEditor(SimpleDiagramElementExtUI,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        SimpleDiagramElementExtUI.__init__(self,parent)
        self.setName("SimpleDiagramElementExt")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.TypeInfoEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.TypeInfoEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.RendererEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.RendererEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.LayouterEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.LayouterEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.UIEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.UIEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ProfileEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ProfileEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        SimpleDiagramElementExtUI.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Addins.SimpleDiagramElementExt]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.TypeInfoEdit.setText(unicode(element.typeInfo))
        self.TypeInfoEdit.setEdited(0)
        
        self.RendererEdit.setText(unicode(element.rendererPath))
        self.RendererEdit.setEdited(0)
        
        self.LayouterEdit.setText(unicode(element.layouterPath))
        self.LayouterEdit.setEdited(0)
        
        self.UIEdit.setText(unicode(element.uiPath))
        self.UIEdit.setEdited(0)
        
        self.ProfileEdit.setText(unicode(element.profile))
        self.ProfileEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.TypeInfoEdit.text())
            self.focus.typeInfo=t
            self.TypeInfoEdit.setEdited(0)
            
            t=unicode(self.RendererEdit.text())
            self.focus.rendererPath=t
            self.RendererEdit.setEdited(0)
            
            t=unicode(self.LayouterEdit.text())
            self.focus.layouterPath=t
            self.LayouterEdit.setEdited(0)
            
            t=unicode(self.UIEdit.text())
            self.focus.uiPath=t
            self.UIEdit.setEdited(0)
            
            t=unicode(self.ProfileEdit.text())
            self.focus.profile=t
            self.ProfileEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

from coral.addins.CoralEx10.DiagramCreator import DiagramCreatorUI

class DiagramCreatorEditor(DiagramCreatorUI,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        DiagramCreatorUI.__init__(self,parent)
        self.setName("DiagramCreator")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ModelKindEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ModelKindEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.TypeInfoEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.TypeInfoEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        DiagramCreatorUI.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Addins.DiagramCreator]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.ModelKindEdit.setText(unicode(element.model_kind))
        self.ModelKindEdit.setEdited(0)
        
        self.TypeInfoEdit.setText(unicode(element.typeInfo))
        self.TypeInfoEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.ModelKindEdit.text())
            self.focus.model_kind=t
            self.ModelKindEdit.setEdited(0)
            
            t=unicode(self.TypeInfoEdit.text())
            self.focus.typeInfo=t
            self.TypeInfoEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class DiagramElementCreatorEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("DiagramElementCreator")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"element_kindLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("element_kind:")
        self.ElementKindEdit=QLineEdit(self,"ElementKindEdit")
        self.ElementKindEdit.setGeometry(QRect(20,80,200,20))
        self.Label3= QLabel(self,"pathLabel")
        self.Label3.setGeometry(QRect(240,10,200,20))
        self.Label3.setText("path:")
        self.PathEdit=QLineEdit(self,"PathEdit")
        self.PathEdit.setGeometry(QRect(240,30,200,20))
        self.Label4= QLabel(self,"orderLabel")
        self.Label4.setGeometry(QRect(240,60,200,20))
        self.Label4.setText("order:")
        self.OrderEdit=QLineEdit(self,"OrderEdit")
        self.OrderEdit.setGeometry(QRect(240,80,200,20))
        self.Label5= QLabel(self,"priorityLabel")
        self.Label5.setGeometry(QRect(240,110,200,20))
        self.Label5.setText("priority:")
        self.PriorityEdit=QLineEdit(self,"PriorityEdit")
        self.PriorityEdit.setGeometry(QRect(240,130,200,20))
        self.setName("DiagramElementCreator")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ElementKindEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ElementKindEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PathEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PathEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.OrderEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.OrderEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PriorityEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PriorityEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Addins.DiagramElementCreator]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.ElementKindEdit.setText(unicode(element.element_kind))
        self.ElementKindEdit.setEdited(0)
        
        self.PathEdit.setText(unicode(element.path))
        self.PathEdit.setEdited(0)
        
        self.OrderEdit.setText(unicode(element.order))
        self.OrderEdit.setEdited(0)
        
        self.PriorityEdit.setText(unicode(element.priority))
        self.PriorityEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.ElementKindEdit.text())
            self.focus.element_kind=t
            self.ElementKindEdit.setEdited(0)
            
            t=unicode(self.PathEdit.text())
            self.focus.path=t
            self.PathEdit.setEdited(0)
            
            t=unicode(self.OrderEdit.text())
            if not t or not t.isdigit():
                print "the value ",t," has to be an integer value"
            else:
                self.focus.order=int(t)
                self.OrderEdit.setEdited(0)
            
            t=unicode(self.PriorityEdit.text())
            if not t or not t.isdigit():
                print "the value ",t," has to be an integer value"
            else:
                self.focus.priority=int(t)
                self.PriorityEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

from coral.addins.CoralEx10.DiagramEditorToolbarEntry import DiagramEditorToolbarEntryUI

class DiagramEditorToolbarEntryEditor(DiagramEditorToolbarEntryUI,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        DiagramEditorToolbarEntryUI.__init__(self,parent)
        self.setName("DiagramEditorToolbarEntry")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.DiagramKindEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.DiagramKindEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PathEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PathEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.OrderEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.OrderEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PriorityEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PriorityEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        DiagramEditorToolbarEntryUI.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Addins.DiagramEditorToolbarEntry]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.DiagramKindEdit.setText(unicode(element.diagram_kind))
        self.DiagramKindEdit.setEdited(0)
        
        self.PathEdit.setText(unicode(element.path))
        self.PathEdit.setEdited(0)
        
        self.OrderEdit.setText(unicode(element.order))
        self.OrderEdit.setEdited(0)
        
        self.PriorityEdit.setText(unicode(element.priority))
        self.PriorityEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.DiagramKindEdit.text())
            self.focus.diagram_kind=t
            self.DiagramKindEdit.setEdited(0)
            
            t=unicode(self.PathEdit.text())
            self.focus.path=t
            self.PathEdit.setEdited(0)
            
            t=unicode(self.OrderEdit.text())
            if not t or not t.isdigit():
                print "the value ",t," has to be an integer value"
            else:
                self.focus.order=int(t)
                self.OrderEdit.setEdited(0)
            
            t=unicode(self.PriorityEdit.text())
            if not t or not t.isdigit():
                print "the value ",t," has to be an integer value"
            else:
                self.focus.priority=int(t)
                self.PriorityEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class PropertyEditorEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("PropertyEditor")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"element_kindLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("element_kind:")
        self.ElementKindEdit=QLineEdit(self,"ElementKindEdit")
        self.ElementKindEdit.setGeometry(QRect(20,80,200,20))
        self.Label3= QLabel(self,"pathLabel")
        self.Label3.setGeometry(QRect(240,10,200,20))
        self.Label3.setText("path:")
        self.PathEdit=QLineEdit(self,"PathEdit")
        self.PathEdit.setGeometry(QRect(240,30,200,20))
        self.Label4= QLabel(self,"orderLabel")
        self.Label4.setGeometry(QRect(240,60,200,20))
        self.Label4.setText("order:")
        self.OrderEdit=QLineEdit(self,"OrderEdit")
        self.OrderEdit.setGeometry(QRect(240,80,200,20))
        self.Label5= QLabel(self,"priorityLabel")
        self.Label5.setGeometry(QRect(240,110,200,20))
        self.Label5.setText("priority:")
        self.PriorityEdit=QLineEdit(self,"PriorityEdit")
        self.PriorityEdit.setGeometry(QRect(240,130,200,20))
        self.setName("PropertyEditor")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ElementKindEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ElementKindEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PathEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PathEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.OrderEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.OrderEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PriorityEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PriorityEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Addins.PropertyEditor]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.ElementKindEdit.setText(unicode(element.element_kind))
        self.ElementKindEdit.setEdited(0)
        
        self.PathEdit.setText(unicode(element.path))
        self.PathEdit.setEdited(0)
        
        self.OrderEdit.setText(unicode(element.order))
        self.OrderEdit.setEdited(0)
        
        self.PriorityEdit.setText(unicode(element.priority))
        self.PriorityEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.ElementKindEdit.text())
            self.focus.element_kind=t
            self.ElementKindEdit.setEdited(0)
            
            t=unicode(self.PathEdit.text())
            self.focus.path=t
            self.PathEdit.setEdited(0)
            
            t=unicode(self.OrderEdit.text())
            if not t or not t.isdigit():
                print "the value ",t," has to be an integer value"
            else:
                self.focus.order=int(t)
                self.OrderEdit.setEdited(0)
            
            t=unicode(self.PriorityEdit.text())
            if not t or not t.isdigit():
                print "the value ",t," has to be an integer value"
            else:
                self.focus.priority=int(t)
                self.PriorityEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class ExtensionToolEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("ExtensionTool")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"pathLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("path:")
        self.PathEdit=QLineEdit(self,"PathEdit")
        self.PathEdit.setGeometry(QRect(240,30,200,20))
        self.setName("ExtensionTool")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PathEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PathEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Addins.ExtensionTool]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.PathEdit.setText(unicode(element.path))
        self.PathEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.PathEdit.text())
            self.focus.path=t
            self.PathEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class ContextMenuActionEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("ContextMenuAction")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"pathLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("path:")
        self.PathEdit=QLineEdit(self,"PathEdit")
        self.PathEdit.setGeometry(QRect(240,30,200,20))
        self.setName("ContextMenuAction")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PathEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PathEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Addins.ContextMenuAction]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.PathEdit.setText(unicode(element.path))
        self.PathEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.PathEdit.text())
            self.focus.path=t
            self.PathEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class CodeGeneratorEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("CodeGenerator")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"pathLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("path:")
        self.PathEdit=QLineEdit(self,"PathEdit")
        self.PathEdit.setGeometry(QRect(240,30,200,20))
        self.setName("CodeGenerator")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PathEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PathEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.CodeGenerator]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.PathEdit.setText(unicode(element.path))
        self.PathEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.PathEdit.text())
            self.focus.path=t
            self.PathEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

from coral.addins.CoralEx10.File import FileUI

class FileEditor(FileUI,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        FileUI.__init__(self,parent)
        self.setName("File")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.LanguageEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.LanguageEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ContentsEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ContentsEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        FileUI.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.FileSystem.File]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.LanguageEdit.setText(unicode(element.language))
        self.LanguageEdit.setEdited(0)
        
        line,index=self.ContentsEdit.getCursorPosition()
        self.ContentsEdit.setText(unicode(element.text))
        self.ContentsEdit.setCursorPosition(line,index)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.LanguageEdit.text())
            self.focus.language=t
            self.LanguageEdit.setEdited(0)
            
            t=unicode(self.ContentsEdit.text())
            self.focus.text=t
            
        finally:
            coral.getTransactionManager().endModifyCmd()

from coral.addins.CoralEx10.Folder import FolderUI

class FolderEditor(FolderUI,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        FolderUI.__init__(self,parent)
        self.setName("Folder")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        FolderUI.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.FileSystem.Folder]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

