import coral
import coral.util.transform.transform as T

from qt import *
from propertyeditors import *

from customwidgets import *
#from coral.modeler.property.propertyeditor import PrimitiveTypeEditorSingleLine
#from coral.modeler import iconcache
#import codegen.portmatch as portmatch

L = coral.lang.DPOTRANS10
TM = coral.getTransactionManager()

class ExtendedTransformationEditor(TransformationViewEditor):
    def __init__(self,editorSet,parent,manager):
        TransformationViewEditor.__init__(self,editorSet,parent,manager)

    def focusOn(self, element):
        """Show the three sets of elements that corresponds to deleted, kept, and added elements."""
        TransformationViewEditor.focusOn(self, element)
        self.element = element
        self.deleteList.clear()
        self.keepList.clear()
        self.addList.clear()

        for elem in self.minus(element.lhs.query, element.rhs, element.mappings == "useQueryElementNames"):
            ElementTypeQListItem(elem, self.deleteList)

        for elem in self.minus(element.rhs, element.lhs.query, element.mappings == "useQueryElementNames"):
            ElementTypeQListItem(elem, self.addList)

        for elem in self.intersect(element.lhs.query, element.rhs, element.mappings == "useQueryElementNames"):
            ElementTypeQListItem(elem, self.keepList)
            
    def minus(self, left_query, right_query, mappByQueryName):
        if mappByQueryName:
            return T.DPOminus(left_query, right_query).abstractElement        
        else:
            left = left_query.queryelement.abstractElement
            right = right_query.queryelement.abstractElement

            lhs=coral.Set()
            rhs=coral.Set()
            for elem in left:
                for part in elem.__getAllParts__():
                    lhs.append(part)

            for elem in right:
                for part in elem.__getAllParts__():
                    rhs.append(part)

            return T.minus(lhs, rhs)

    def intersect(self, left_query, right_query, mappByQueryName):
        if mappByQueryName:
            return T.DPOintersect(left_query, right_query).abstractElement
        else:
            left = left_query.queryelement.abstractElement
            right = right_query.queryelement.abstractElement

            lhs=coral.Set()
            rhs=coral.Set()
            for elem in left:
                #for part in elem.__getAllParts__():
                lhs.append(elem)

            for elem in right:
                #for part in elem.__getAllParts__():
                rhs.append(elem)

            return T.intersection(lhs, rhs)
        

