# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.ESMD10
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache


class PropertyEditorsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "PropertyEditors"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.LanguageEditor]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [CompositePropertyEditorEditor,ElementPropertyEditorEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "propertyEditor"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        candidates=coral.Set()
        l=self.focus.__type__().__language__()
        candidates.append(l.ElementPropertyEditor)
        candidates.append(l.CompositePropertyEditor)
        
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
        	newClass=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
        	newClass=None
        	return
                
        if newClass:
        	o=newClass()
        	setattr(o,"name","(noname)")
        	self.focus.propertyEditor.append(o)
        	return o
    elementFactory = staticmethod(elementFactory)


class ElementPropertyEditorEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("ElementPropertyEditor")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"caneditLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("canedit:")
        self.canEditEdit=QTextEdit(self,"canEditEdit")
        self.canEditEdit.setGeometry(QRect(20,80,300,200))
        self.Label3= QLabel(self,"uiclassnameLabel")
        self.Label3.setGeometry(QRect(340,10,200,20))
        self.Label3.setText("uiclassname:")
        self.uiClassEdit=QLineEdit(self,"uiClassEdit")
        self.uiClassEdit.setGeometry(QRect(340,30,200,20))
        self.Label4= QLabel(self,"uifileLabel")
        self.Label4.setGeometry(QRect(340,60,200,20))
        self.Label4.setText("uifile:")
        self.uiFileEdit=QLineEdit(self,"uiFileEdit")
        self.uiFileEdit.setGeometry(QRect(340,80,200,20))
        self.setName("ElementPropertyEditor")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.canEditEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.canEditEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.uiClassEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.uiClassEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.uiFileEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.uiFileEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.ElementPropertyEditor]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        txt="\n".join([unicode(line) for line in element.canedit]) 
        self.canEditEdit.setText(unicode(txt))
        
        self.uiClassEdit.setText(unicode(element.uiclassname))
        self.uiClassEdit.setEdited(0)
        
        self.uiFileEdit.setText(unicode(element.uifile))
        self.uiFileEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.canEditEdit.text())
            self.focus.canedit = []
            for s in t.split("\n"):
            	st = coral.String.newAtom()
            	st.__setString__(s)
            	self.focus.canedit.append(st)
            
            t=unicode(self.uiClassEdit.text())
            self.focus.uiclassname=t
            self.uiClassEdit.setEdited(0)
            
            t=unicode(self.uiFileEdit.text())
            self.focus.uifile=t
            self.uiFileEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class CompositePropertyEditorEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("CompositePropertyEditor")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"associationnameLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("associationname:")
        self.AssociationNameEdit=QLineEdit(self,"AssociationNameEdit")
        self.AssociationNameEdit.setGeometry(QRect(20,80,200,20))
        self.Label3= QLabel(self,"filterassociationLabel")
        self.Label3.setGeometry(QRect(240,10,200,20))
        self.Label3.setText("filterassociation:")
        self.FilterAssociationEdit=QLineEdit(self,"FilterAssociationEdit")
        self.FilterAssociationEdit.setGeometry(QRect(240,30,200,20))
        self.Label4= QLabel(self,"caneditLabel")
        self.Label4.setGeometry(QRect(240,60,200,20))
        self.Label4.setText("canedit:")
        self.CanEditEdit=QTextEdit(self,"CanEditEdit")
        self.CanEditEdit.setGeometry(QRect(240,80,300,200))
        self.Label5= QLabel(self,"elementfactoryLabel")
        self.Label5.setGeometry(QRect(240,290,200,20))
        self.Label5.setText("elementfactory:")
        self.ElementFactoryEdit=QTextEdit(self,"ElementFactoryEdit")
        self.ElementFactoryEdit.setGeometry(QRect(240,310,300,200))
        self.setName("CompositePropertyEditor")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.AssociationNameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.AssociationNameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.FilterAssociationEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.FilterAssociationEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.CanEditEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.CanEditEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ElementFactoryEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ElementFactoryEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.CompositePropertyEditor]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.AssociationNameEdit.setText(unicode(element.associationname))
        self.AssociationNameEdit.setEdited(0)
        
        self.FilterAssociationEdit.setText(unicode(element.filterassociation))
        self.FilterAssociationEdit.setEdited(0)
        
        txt="\n".join([unicode(line) for line in element.canedit]) 
        self.CanEditEdit.setText(unicode(txt))
        
        txt="\n".join([unicode(line) for line in element.elementfactory]) 
        self.ElementFactoryEdit.setText(unicode(txt))
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.AssociationNameEdit.text())
            self.focus.associationname=t
            self.AssociationNameEdit.setEdited(0)
            
            t=unicode(self.FilterAssociationEdit.text())
            self.focus.filterassociation=t
            self.FilterAssociationEdit.setEdited(0)
            
            t=unicode(self.CanEditEdit.text())
            self.focus.canedit = []
            for s in t.split("\n"):
            	st = coral.String.newAtom()
            	st.__setString__(s)
            	self.focus.canedit.append(st)
            
            t=unicode(self.ElementFactoryEdit.text())
            self.focus.elementfactory= []
            for s in t.split("\n"):
             st = coral.String.newAtom()
             st.__setString__(s)
             self.focus.elementfactory.append(st)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class FieldEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Field")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"propertyLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("property:")
        self.PropertyEdit=QLineEdit(self,"PropertyEdit")
        self.PropertyEdit.setGeometry(QRect(20,80,200,20))
        self.Label3= QLabel(self,"towidgetLabel")
        self.Label3.setGeometry(QRect(20,110,200,20))
        self.Label3.setText("towidget:")
        self.ToWidgetEdit=QTextEdit(self,"ToWidgetEdit")
        self.ToWidgetEdit.setGeometry(QRect(20,130,300,200))
        self.Label4= QLabel(self,"widgetLabel")
        self.Label4.setGeometry(QRect(340,10,200,20))
        self.Label4.setText("widget:")
        self.WidgetEdit=QLineEdit(self,"WidgetEdit")
        self.WidgetEdit.setGeometry(QRect(340,30,200,20))
        self.Label5= QLabel(self,"editorLabel")
        self.Label5.setGeometry(QRect(340,60,200,20))
        self.Label5.setText("editor:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.EditorEdit=ReferenceLineEdit(self,"EditorEdit")
        self.EditorEdit.setGeometry(QRect(340,80,200,20))
        noselect = False
        self.NewEditor=QToolButton(self,"NewEditor")
        self.NewEditor.setGeometry(QRect(550,75,28,28))
        self.NewEditor.setPixmap(iconcache.getIcon("newAction"))
        self.NewEditor.setTextLabel("New Element")
        self.SelectEditor=QToolButton(self,"SelectEditor")
        if noselect:
            self.SelectEditor.setGeometry(QRect(550,75,28,28))
        else:
            self.SelectEditor.setGeometry(QRect(590,75,28,28))
        self.SelectEditor.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectEditor.setTextLabel("Select Element")
        self.Label6= QLabel(self,"fromwidgetLabel")
        self.Label6.setGeometry(QRect(340,110,200,20))
        self.Label6.setText("fromwidget:")
        self.FromWidgetEdit=QTextEdit(self,"FromWidgetEdit")
        self.FromWidgetEdit.setGeometry(QRect(340,130,300,200))
        self.setName("Field")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PropertyEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PropertyEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ToWidgetEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ToWidgetEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.WidgetEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.WidgetEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.EditorEdit.setReadOnly(True)
        self.connect(self.NewEditor,SIGNAL('clicked()'),self.NewEditorClicked)
        self.connect(self.SelectEditor,SIGNAL('clicked()'),self.SelectEditorClicked)
        self.fieldTarget = None
        self.connect(self.FromWidgetEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.FromWidgetEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.BooleanField,L.EnumerationField,L.TextField,L.IntegerField,L.StringField]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.editor
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.PropertyEdit.setText(unicode(element.property))
        self.PropertyEdit.setEdited(0)
        
        txt="\n".join([unicode(line) for line in element.towidget]) 
        self.ToWidgetEdit.setText(unicode(txt))
        
        self.WidgetEdit.setText(unicode(element.widget))
        self.WidgetEdit.setEdited(0)
        
        self.EditorEdit.setText("")
        if element.editor:
            self.EditorEdit.setText(getFQName(element.editor,1))
            self.EditorEdit.setEdited(0)
        
        txt="\n".join([unicode(line) for line in element.fromwidget]) 
        self.FromWidgetEdit.setText(unicode(txt))
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.PropertyEdit.text())
            self.focus.property=t
            self.PropertyEdit.setEdited(0)
            
            t=unicode(self.ToWidgetEdit.text())
            self.focus.towidget = []
            for s in t.split("\n"):
            	st = coral.String.newAtom()
            	st.__setString__(s)
            	self.focus.towidget.append(st)
            
            t=unicode(self.WidgetEdit.text())
            self.focus.widget=t
            self.WidgetEdit.setEdited(0)
            
            
            t=unicode(self.FromWidgetEdit.text())
            self.focus.fromwidget = []
            for s in t.split("\n"):
            	st = coral.String.newAtom()
            	st.__setString__(s)
            	self.focus.fromwidget.append(st)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectEditorClicked(self):
        ed=self.focus.__type__().getPropertyByName("editor").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.editor=r
            self.EditorEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewEditorClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            if self.focus:
            	langEdit=self.focus.editor.languageEditor
            	new=L.ElementPropertyEditor()
            	langEdit.propertyEditor.append(new)
            	self.focus.editor=new
            	self.EditorEdit.setText(getFQName(new,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class FieldsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Fields"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.ElementPropertyEditor]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [ReferenceFieldEditor,FieldEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "field"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        l=self.focus.__type__().__language__()
        candidates = coral.inheritanceTree(l.Field)
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
        	newClass=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
        	newClass=None
        	return
                
        if newClass:
        	o=newClass()
        	setattr(o,"name","(noname)")
        	self.focus.field.append(o)
        	return o
    elementFactory = staticmethod(elementFactory)


class ReferenceFieldEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("ReferenceField")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"propertyLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("property:")
        self.PropertyEdit=QLineEdit(self,"PropertyEdit")
        self.PropertyEdit.setGeometry(QRect(20,80,200,20))
        self.Label3= QLabel(self,"widgetLabel")
        self.Label3.setGeometry(QRect(20,110,200,20))
        self.Label3.setText("widget:")
        self.WidgetEdit=QLineEdit(self,"WidgetEdit")
        self.WidgetEdit.setGeometry(QRect(20,130,200,20))
        self.Label4= QLabel(self,"newElementLabel")
        self.Label4.setGeometry(QRect(20,160,200,20))
        self.Label4.setText("newElement:")
        self.NewElementEdit=QTextEdit(self,"NewElementEdit")
        self.NewElementEdit.setGeometry(QRect(20,180,300,200))
        self.Label5= QLabel(self,"newwidgetLabel")
        self.Label5.setGeometry(QRect(340,10,200,20))
        self.Label5.setText("newwidget:")
        self.NewWidgetEdit=QLineEdit(self,"NewWidgetEdit")
        self.NewWidgetEdit.setGeometry(QRect(340,30,200,20))
        self.Label6= QLabel(self,"selectwidgetLabel")
        self.Label6.setGeometry(QRect(340,60,200,20))
        self.Label6.setText("selectwidget:")
        self.SelectWidgetEdit=QLineEdit(self,"SelectWidgetEdit")
        self.SelectWidgetEdit.setGeometry(QRect(340,80,200,20))
        self.Label7= QLabel(self,"editorLabel")
        self.Label7.setGeometry(QRect(340,110,200,20))
        self.Label7.setText("editor:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.EditorEdit=ReferenceLineEdit(self,"EditorEdit")
        self.EditorEdit.setGeometry(QRect(340,130,200,20))
        noselect = False
        self.NewEditor=QToolButton(self,"NewEditor")
        self.NewEditor.setGeometry(QRect(550,125,28,28))
        self.NewEditor.setPixmap(iconcache.getIcon("newAction"))
        self.NewEditor.setTextLabel("New Element")
        association = False
        for mc in [L.ReferenceField]:
            if mc.getPropertyByName("editor") and mc.getPropertyByName("editor").isAssociation():
                association = True
                self.NewEditor.setHidden(True)
                noselect = True
                break
        self.SelectEditor=QToolButton(self,"SelectEditor")
        if noselect:
            self.SelectEditor.setGeometry(QRect(550,125,28,28))
        else:
            self.SelectEditor.setGeometry(QRect(590,125,28,28))
        self.SelectEditor.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectEditor.setTextLabel("Select Element")
        self.Label8= QLabel(self,"fromwidgetLabel")
        self.Label8.setGeometry(QRect(340,160,200,20))
        self.Label8.setText("fromwidget:")
        self.FromWidgetEdit=QTextEdit(self,"FromWidgetEdit")
        self.FromWidgetEdit.setGeometry(QRect(340,180,300,200))
        self.Label9= QLabel(self,"towidgetLabel")
        self.Label9.setGeometry(QRect(340,390,200,20))
        self.Label9.setText("towidget:")
        self.ToWidgetEdit=QTextEdit(self,"ToWidgetEdit")
        self.ToWidgetEdit.setGeometry(QRect(340,410,300,200))
        self.setName("ReferenceField")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.PropertyEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.PropertyEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.WidgetEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.WidgetEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.NewElementEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.NewElementEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NewWidgetEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NewWidgetEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.SelectWidgetEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.SelectWidgetEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.EditorEdit.setReadOnly(True)
        self.connect(self.NewEditor,SIGNAL('clicked()'),self.NewEditorClicked)
        self.connect(self.SelectEditor,SIGNAL('clicked()'),self.SelectEditorClicked)
        self.fieldTarget = None
        self.connect(self.FromWidgetEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.FromWidgetEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ToWidgetEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ToWidgetEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.ReferenceField]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.editor
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.PropertyEdit.setText(unicode(element.property))
        self.PropertyEdit.setEdited(0)
        
        self.WidgetEdit.setText(unicode(element.widget))
        self.WidgetEdit.setEdited(0)
        
        txt="\n".join([unicode(line) for line in element.newElement]) 
        self.NewElementEdit.setText(unicode(txt)) 
        
        self.NewWidgetEdit.setText(unicode(element.newwidget))
        self.NewWidgetEdit.setEdited(0)
        
        self.SelectWidgetEdit.setText(unicode(element.selectwidget))
        self.SelectWidgetEdit.setEdited(0)
        
        self.EditorEdit.setText("")
        if element.editor:
            self.EditorEdit.setText(getFQName(element.editor,1))
            self.EditorEdit.setEdited(0)
        
        txt="\n".join([unicode(line) for line in element.fromwidget]) 
        self.FromWidgetEdit.setText(unicode(txt))
        
        txt="\n".join([unicode(line) for line in element.towidget]) 
        self.ToWidgetEdit.setText(unicode(txt))
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.PropertyEdit.text())
            self.focus.property=t
            self.PropertyEdit.setEdited(0)
            
            t=unicode(self.WidgetEdit.text())
            self.focus.widget=t
            self.WidgetEdit.setEdited(0)
            
            t=unicode(self.NewElementEdit.text())
            self.focus.newElement = []
            for s in t.split("\n"):
            	st = coral.String.newAtom()
            	st.__setString__(s)
            	self.focus.newElement.append(st)
            
            t=unicode(self.NewWidgetEdit.text())
            self.focus.newwidget=t
            self.NewWidgetEdit.setEdited(0)
            
            t=unicode(self.SelectWidgetEdit.text())
            self.focus.selectwidget=t
            self.SelectWidgetEdit.setEdited(0)
            
            
            t=unicode(self.FromWidgetEdit.text())
            self.focus.fromwidget = []
            for s in t.split("\n"):
            	st = coral.String.newAtom()
            	st.__setString__(s)
            	self.focus.fromwidget.append(st)
            
            t=unicode(self.ToWidgetEdit.text())
            self.focus.towidget = []
            for s in t.split("\n"):
            	st = coral.String.newAtom()
            	st.__setString__(s)
            	self.focus.towidget.append(st)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectEditorClicked(self):
        ed=self.focus.__type__().getPropertyByName("editor").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.editor=r
            self.EditorEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewEditorClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("editor")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class LanguageEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Language")
        self.Label1= QLabel(self,"languageNameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("languageName:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"languageVersionLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("languageVersion:")
        self.VersionEdit=QLineEdit(self,"VersionEdit")
        self.VersionEdit.setGeometry(QRect(240,30,200,20))
        self.Label3= QLabel(self,"languageRevisionLabel")
        self.Label3.setGeometry(QRect(240,60,200,20))
        self.Label3.setText("languageRevision:")
        self.RevisionEdit=QLineEdit(self,"RevisionEdit")
        self.RevisionEdit.setGeometry(QRect(240,80,200,20))
        self.setName("Language")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.VersionEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.VersionEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.RevisionEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.RevisionEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.LanguageEditor]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.languageName))
        self.NameEdit.setEdited(0)
        
        self.VersionEdit.setText(unicode(element.languageVersion))
        self.VersionEdit.setEdited(0)
        
        self.RevisionEdit.setText(unicode(element.languageRevision))
        self.RevisionEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.languageName=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.VersionEdit.text())
            if not t or not t.isdigit():
                print "the value ",t," has to be an integer value"
            else:
                self.focus.languageVersion=int(t)
                self.VersionEdit.setEdited(0)
            
            t=unicode(self.RevisionEdit.text())
            if not t or not t.isdigit():
                print "the value ",t," has to be an integer value"
            else:
                self.focus.languageRevision=int(t)
                self.RevisionEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class SubEditorsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "SubEditors"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.CompositePropertyEditor]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [CompositePropertyEditorEditor,ElementPropertyEditorEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "part"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        candidates=coral.Set()
        l=self.focus.__type__().__language__()
        candidates.append(l.ElementPropertyEditor)
        candidates.append(l.CompositePropertyEditor)
        
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
         newClass=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
         newClass=None
         return
                
        if newClass:
         o=newClass()
         setattr(o,"name","(noname)")
         self.focus.languageEditor.propertyEditor.append(o)
         self.focus.part.append(o)
         return o
    elementFactory = staticmethod(elementFactory)

