# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.FSM10
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache


class TokenEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Token")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("Token")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Token]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class StateEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("State")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("State")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.State]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class StateMachineEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("StateMachine")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"initialLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("initial:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.InitialEdit=ReferenceLineEdit(self,"InitialEdit")
        self.InitialEdit.setGeometry(QRect(240,30,200,20))
        noselect = False
        self.NewInitial=QToolButton(self,"NewInitial")
        self.NewInitial.setGeometry(QRect(450,25,28,28))
        self.NewInitial.setPixmap(iconcache.getIcon("newAction"))
        self.NewInitial.setTextLabel("New Element")
        self.SelectInitial=QToolButton(self,"SelectInitial")
        if noselect:
            self.SelectInitial.setGeometry(QRect(450,25,28,28))
        else:
            self.SelectInitial.setGeometry(QRect(490,25,28,28))
        self.SelectInitial.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectInitial.setTextLabel("Select Element")
        self.setName("StateMachine")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.InitialEdit.setReadOnly(True)
        self.connect(self.NewInitial,SIGNAL('clicked()'),self.NewInitialClicked)
        self.connect(self.SelectInitial,SIGNAL('clicked()'),self.SelectInitialClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.StateMachine]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.initial
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.InitialEdit.setText("")
        if element.initial:
            self.InitialEdit.setText(getFQName(element.initial,1))
            self.InitialEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectInitialClicked(self):
        ed=self.focus.__type__().getPropertyByName("initial").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.initial=r
            self.InitialEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewInitialClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("initial")
            candidates = coral.inheritanceTree(prop.getTarget())
            sorted_candidates = [i for i in candidates ]
            sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
            dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
            if dlg.exec_loop():
             newState=sorted_candidates[dlg.ComboBox1.currentItem()]
            else:
             newState=None
             return
            if newState:
             o=newState()
             setattr(o,"name","(noname)")
            
            package=self.focus
            package.state.insert(o)
            self.focus.initial=o
            self.InitialEdit.setText(getFQName(o,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class TransitionEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Transition")
        self.Label1= QLabel(self,"triggerLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("trigger:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.TriggerEdit=ReferenceLineEdit(self,"TriggerEdit")
        self.TriggerEdit.setGeometry(QRect(20,30,200,20))
        noselect = False
        self.NewTrigger=QToolButton(self,"NewTrigger")
        self.NewTrigger.setGeometry(QRect(230,25,28,28))
        self.NewTrigger.setPixmap(iconcache.getIcon("newAction"))
        self.NewTrigger.setTextLabel("New Element")
        self.SelectTrigger=QToolButton(self,"SelectTrigger")
        if noselect:
            self.SelectTrigger.setGeometry(QRect(230,25,28,28))
        else:
            self.SelectTrigger.setGeometry(QRect(270,25,28,28))
        self.SelectTrigger.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectTrigger.setTextLabel("Select Element")
        self.Label2= QLabel(self,"targetLabel")
        self.Label2.setGeometry(QRect(310,10,200,20))
        self.Label2.setText("target:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.TargetEdit=ReferenceLineEdit(self,"TargetEdit")
        self.TargetEdit.setGeometry(QRect(310,30,200,20))
        noselect = False
        self.NewTarget=QToolButton(self,"NewTarget")
        self.NewTarget.setGeometry(QRect(520,25,28,28))
        self.NewTarget.setPixmap(iconcache.getIcon("newAction"))
        self.NewTarget.setTextLabel("New Element")
        self.SelectTarget=QToolButton(self,"SelectTarget")
        if noselect:
            self.SelectTarget.setGeometry(QRect(520,25,28,28))
        else:
            self.SelectTarget.setGeometry(QRect(560,25,28,28))
        self.SelectTarget.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectTarget.setTextLabel("Select Element")
        self.Label3= QLabel(self,"sourceLabel")
        self.Label3.setGeometry(QRect(310,60,200,20))
        self.Label3.setText("source:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.SourceEdit=ReferenceLineEdit(self,"SourceEdit")
        self.SourceEdit.setGeometry(QRect(310,80,200,20))
        noselect = False
        self.NewSource=QToolButton(self,"NewSource")
        self.NewSource.setGeometry(QRect(520,75,28,28))
        self.NewSource.setPixmap(iconcache.getIcon("newAction"))
        self.NewSource.setTextLabel("New Element")
        self.SelectSource=QToolButton(self,"SelectSource")
        if noselect:
            self.SelectSource.setGeometry(QRect(520,75,28,28))
        else:
            self.SelectSource.setGeometry(QRect(560,75,28,28))
        self.SelectSource.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectSource.setTextLabel("Select Element")
        self.setName("Transition")
        self.TriggerEdit.setReadOnly(True)
        self.connect(self.NewTrigger,SIGNAL('clicked()'),self.NewTriggerClicked)
        self.connect(self.SelectTrigger,SIGNAL('clicked()'),self.SelectTriggerClicked)
        self.fieldTarget = None
        self.TargetEdit.setReadOnly(True)
        self.connect(self.NewTarget,SIGNAL('clicked()'),self.NewTargetClicked)
        self.connect(self.SelectTarget,SIGNAL('clicked()'),self.SelectTargetClicked)
        self.fieldTarget = None
        self.SourceEdit.setReadOnly(True)
        self.connect(self.NewSource,SIGNAL('clicked()'),self.NewSourceClicked)
        self.connect(self.SelectSource,SIGNAL('clicked()'),self.SelectSourceClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.Transition]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.trigger
        self.fieldTarget=element.target
        self.fieldTarget=element.source
        PropertyEditor.focusOn(self,element)
        self.TriggerEdit.setText("")
        if element.trigger:
            self.TriggerEdit.setText(getFQName(element.trigger,1))
            self.TriggerEdit.setEdited(0)
        
        self.TargetEdit.setText("")
        if element.target:
            self.TargetEdit.setText(getFQName(element.target,1))
            self.TargetEdit.setEdited(0)
        
        self.SourceEdit.setText("")
        if element.source:
            self.SourceEdit.setText(getFQName(element.source,1))
            self.SourceEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectTriggerClicked(self):
        ed=self.focus.__type__().getPropertyByName("trigger").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.trigger=r
            self.TriggerEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewTriggerClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            if self.focus:
                sm=self.focus.stateMachine
                new=L.Token()
                sm.alphabet.insert(new)
                self.focus.trigger=new
                self.TriggerEdit.setText(getFQName(new,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectTargetClicked(self):
        ed=self.focus.__type__().getPropertyByName("target").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.target=r
            self.TargetEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewTargetClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("target")
            candidates = coral.inheritanceTree(prop.getTarget())
            sorted_candidates = [i for i in candidates ]
            sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
            dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
            if dlg.exec_loop():
             newState=sorted_candidates[dlg.ComboBox1.currentItem()]
            else:
             newState=None
             return
            if newState:
             o=newState()
             setattr(o,"name","(noname)")
            
            package=self.focus.stateMachine
            package.state.insert(o)
            self.focus.target=o
            self.TargetlEdit.setText(getFQName(o,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectSourceClicked(self):
        ed=self.focus.__type__().getPropertyByName("source").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.source=r
            self.SourceEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewSourceClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("source")
            candidates = coral.inheritanceTree(prop.getTarget())
            sorted_candidates = [i for i in candidates ]
            sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
            dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
            if dlg.exec_loop():
             newState=sorted_candidates[dlg.ComboBox1.currentItem()]
            else:
             newState=None
             return
            if newState:
             o=newState()
             setattr(o,"name","(noname)")
            
            package=self.focus.stateMachine
            package.state.insert(o)
            self.focus.source=o
            self.SourcelEdit.setText(getFQName(o,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class StatesEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "States"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.StateMachine]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [StateEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "state"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        prop=self.focus.__type__().getPropertyByName("state")
        candidates = coral.inheritanceTree(prop.getTarget())
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
         newState=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
         newState=None
         return
                
        if newState:
         o=newState()
         setattr(o,"name","(noname)")
         self.focus.state.append(o)
         return o
    elementFactory = staticmethod(elementFactory)


class TokensEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Tokens"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.StateMachine]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [TokenEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "alphabet"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(self.focus.alphabet,'token')
        return L.Token(name=name)
    elementFactory = staticmethod(elementFactory)


class TransitionsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Transitions"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.StateMachine]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [TransitionEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "transition"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        return L.Transition()
    elementFactory = staticmethod(elementFactory)

