# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.MATCH10
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache

from coral.addins.MATCH10.ExpressionMatchPE import ExpressionMatchPE

class ExpressionMatchEditor(ExpressionMatchPE,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        ExpressionMatchPE.__init__(self,parent)
        self.setName("ExpressionMatch")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ScriptEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('returnPressed()'),self.apply)
        self.TargetEdit.setReadOnly(True)
        self.connect(self.dummyButton,SIGNAL('clicked()'),self.dummyButtonClicked)
        self.connect(self.pickED,SIGNAL('clicked()'),self.pickEDClicked)
        self.fieldTarget = None
        self.connect(self.lookUpEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.lookUpEdit,SIGNAL('activated(int)'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        ExpressionMatchPE.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.ExpressionMatch]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.kind
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.DescriptionEdit.getCursorPosition()
        self.DescriptionEdit.setText(unicode(element.description))
        self.DescriptionEdit.setCursorPosition(line,index)
        
        line,index=self.ScriptEdit.getCursorPosition()
        self.ScriptEdit.setText(unicode(element.script))
        self.ScriptEdit.setCursorPosition(line,index)
        
        self.TargetEdit.setText("")
        if element.kind:
            self.TargetEdit.setText(getFQName(element.kind,1))
            self.TargetEdit.setEdited(0)
        
        self.lookUpEdit.clear()
        property = element.__type__().getPropertyByName("lookUp")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.lookUpEdit.insertItem(ed.getDescription(i))
        self.lookUpEdit.setCurrentItem(element.lookUp.__getEValue__())
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.DescriptionEdit.text())
            self.focus.description=t
            
            t=unicode(self.ScriptEdit.text())
            self.focus.script=t
            
            
            self.focus.lookUp=self.lookUpEdit.currentItem()
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def pickEDClicked(self):
        ed=self.focus.__type__().getPropertyByName("kind").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.kind=r
            self.TargetEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def dummyButtonClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            pass
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class MatchesEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Matches"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Package]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def filterAssociation(e):
        if e.oclIsKindOf(L.Match):
            return 1
        return 0
    filterAssociation = staticmethod(filterAssociation)

    def getSubEditors():
        return [ExpressionMatchEditor,GraphMatchEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "element"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        def getAllSubclasses(ElemDef):
         sub=coral.Set()
         if not ElemDef.isAbstract():
          sub.append(ElemDef)
         for sc in ElemDef.getSubclasses():
          if sc.isAbstract():
            continue
          sub.unionWith(getAllSubclasses(sc))
         return sub
        
        candidates=coral.Set()
        l=getAllSubclasses(L.Match)
        for element in l:
         candidates.append(element)
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
         newClass=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
         newClass=None
         return
                
        if newClass:
         o=newClass()
         setattr(o,"name","(noname)")
         focus.element.append(o)
         return o
    elementFactory = staticmethod(elementFactory)

from coral.addins.MATCH10.GraphMatchPE import GraphMatchPE

class GraphMatchEditor(GraphMatchPE,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        GraphMatchPE.__init__(self,parent)
        self.setName("GraphMatch")
        self.connect(self.DescriptionEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('returnPressed()'),self.apply)
        self.mainElementEdit.setReadOnly(True)
        self.connect(self.dummyButton,SIGNAL('clicked()'),self.dummyButtonClicked)
        self.connect(self.pickED,SIGNAL('clicked()'),self.pickEDClicked)
        self.fieldTarget = None
        self.connect(self.QueryKindEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.QueryKindEdit,SIGNAL('activated(int)'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        GraphMatchPE.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.GraphMatch]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.mainElement
        PropertyEditor.focusOn(self,element)
        line,index=self.DescriptionEdit.getCursorPosition()
        self.DescriptionEdit.setText(unicode(element.description))
        self.DescriptionEdit.setCursorPosition(line,index)
        
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.ScriptEdit.getCursorPosition()
        self.ScriptEdit.setText(unicode(element.script))
        self.ScriptEdit.setCursorPosition(line,index)
        
        self.mainElementEdit.setText("")
        if element.mainElement:
            self.mainElementEdit.setText(getFQName(element.mainElement,1))
            self.mainElementEdit.setEdited(0)
        
        self.QueryKindEdit.clear()
        property = element.__type__().getPropertyByName("queryKind")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.QueryKindEdit.insertItem(ed.getDescription(i))
        self.QueryKindEdit.setCurrentItem(element.queryKind.__getEValue__())
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.DescriptionEdit.text())
            self.focus.description=t
            
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.ScriptEdit.text())
            self.focus.script=t
            
            
            self.focus.queryKind=self.QueryKindEdit.currentItem()
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def pickEDClicked(self):
        ed=self.focus.__type__().getPropertyByName("mainElement").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.mainElement=r
            self.mainElementEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def dummyButtonClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            pass
        finally:
            coral.getTransactionManager().endModifyCmd()
            
