import coral
import os,sys

from coral.util.user import getUserHome

INSTALL_AT_USERHOME=0
INSTALL_AT_CORALHOME=1

def install_SMD_language_User(language):
    import qt
    where=qt.QMessageBox.question(None,"SMD Language Location",
                                  "You can install this language in your home folder or in the Coral application folder.\n  -If you install the language in your home folder it will be available only to you.\n  -If you install it in the application folder it will be avilable to all users in this machine.\n      However, you may not have the right to modify the Coral application folder.\n\nWhere shoud the language be installed?","Install in home foder","Install in application folder","Cancel",0,2)
    if where!=2:
        install_SMD_language(language,where)
    
def install_SMD_language(language,
                         where_to_install=INSTALL_AT_USERHOME):
    
    assert  language.oclIsKindOf(coral.meta.SMD01.Language)
    assert (str(language.name)!="")
    name=str(language.name)+str(language.version)+str(language.revision)

    if where_to_install==INSTALL_AT_USERHOME: 
        rootFolder=getUserHome()+"/.coral/"
    else:
        rootFolder=coral.installation_path
        
    try:
        os.mkdir(rootFolder+"/coral/lang/"+name)
        os.mkdir(rootFolder+"/coral/lang/"+name+"/def")
    except:
        pass

    fname = rootFolder+"/coral/lang/"+name+"/manifest.txt"
    fd=open(fname, "w")
    fd.write("name "+str(language.name)+"\n")
    fd.write("version "+str(language.version)+"\n")
    fd.write("revision "+str(language.revision)+"\n")
    fd.write("file def/"+name+".xmi\n")
    fd.write("xmlns "+str(language.URInamespace)+"\n")
    fd.close()
    
    oldPrj=language.__getProject__()

    try:
        newPrj=coral.Project()
        language.__setProject__(newPrj)
        xmifname = rootFolder+"/coral/lang/"+name+"/def/"+name+".xmi"
        newPrj.setFilename(xmifname)
        newPrj.saveToDocument()

        coral.addXMLNSRmap(str(language.URInamespace),
                           str(xmifname),
                           str(language.name),
                           int(language.version),
                           int(language.revision))
    finally:
        language.__setProject__(oldPrj)

    
