# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.TEXTAGEN10
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache

from coral.addins.TEXTAGEN10.ExpressionTextGenPE import ExpressionTextGenPE

class ExpressionTextGenEditor(ExpressionTextGenPE,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        ExpressionTextGenPE.__init__(self,parent)
        self.setName("ExpressionTextGen")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.ScriptEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('returnPressed()'),self.apply)
        self.TargetEdit.setReadOnly(True)
        self.connect(self.dummyButton,SIGNAL('clicked()'),self.dummyButtonClicked)
        self.connect(self.pickED,SIGNAL('clicked()'),self.pickEDClicked)
        self.fieldTarget = None
        self.connect(self.autoIndentEdit,SIGNAL('clicked()'),self.changed)
        self.connect(self.autoIndentEdit,SIGNAL('clicked()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        ExpressionTextGenPE.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.ExpressionTextGen]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.match
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.DescriptionEdit.getCursorPosition()
        self.DescriptionEdit.setText(unicode(element.description))
        self.DescriptionEdit.setCursorPosition(line,index)
        
        line,index=self.ScriptEdit.getCursorPosition()
        self.ScriptEdit.setText(unicode(element.expression))
        self.ScriptEdit.setCursorPosition(line,index)
        
        self.TargetEdit.setText("")
        if element.match:
            self.TargetEdit.setText(getFQName(element.match,1))
            self.TargetEdit.setEdited(0)
        
        self.autoIndentEdit.setChecked(element.autoIndent)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.DescriptionEdit.text())
            self.focus.description=t
            
            t=unicode(self.ScriptEdit.text())
            self.focus.expression=t
            
            
            self.focus.autoIndent=self.autoIndentEdit.isChecked()
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def pickEDClicked(self):
        ed=self.focus.__type__().getPropertyByName("match").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.match=r
            self.TargetEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def dummyButtonClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            pass
        finally:
            coral.getTransactionManager().endModifyCmd()
            
from coral.addins.TEXTAGEN10.TemplateTextGenPE import TemplateTextGenPE

class TemplateTextGenEditor(TemplateTextGenPE,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        TemplateTextGenPE.__init__(self,parent)
        self.setName("TemplateTextGen")
        self.connect(self.DescriptionEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('returnPressed()'),self.apply)
        self.TargetEdit.setReadOnly(True)
        self.connect(self.dummyButton,SIGNAL('clicked()'),self.dummyButtonClicked)
        self.connect(self.pickED,SIGNAL('clicked()'),self.pickEDClicked)
        self.fieldTarget = None
        self.connect(self.autoIndentEdit,SIGNAL('clicked()'),self.changed)
        self.connect(self.autoIndentEdit,SIGNAL('clicked()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        TemplateTextGenPE.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.TemplateTextGen]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.match
        PropertyEditor.focusOn(self,element)
        line,index=self.DescriptionEdit.getCursorPosition()
        self.DescriptionEdit.setText(unicode(element.description))
        self.DescriptionEdit.setCursorPosition(line,index)
        
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.ScriptEdit.getCursorPosition()
        self.ScriptEdit.setText(unicode(element.template))
        self.ScriptEdit.setCursorPosition(line,index)
        
        self.TargetEdit.setText("")
        if element.match:
            self.TargetEdit.setText(getFQName(element.match,1))
            self.TargetEdit.setEdited(0)
        
        self.autoIndentEdit.setChecked(element.autoIndent)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.DescriptionEdit.text())
            self.focus.description=t
            
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.ScriptEdit.text())
            self.focus.template=t
            
            
            self.focus.autoIndent=self.autoIndentEdit.isChecked()
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def pickEDClicked(self):
        ed=self.focus.__type__().getPropertyByName("match").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.match=r
            self.TargetEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def dummyButtonClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            pass
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class TextGenEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "TextGen"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.FileGen]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def filterAssociation(e):
        if e.oclIsKindOf(L.TextGen):
            return 1
        return 0
    filterAssociation = staticmethod(filterAssociation)

    def getSubEditors():
        return [ExpressionTextGenEditor,TemplateTextGenEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "text"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        def getAllSubclasses(ElemDef):
         sub=coral.Set()
         if not ElemDef.isAbstract():
          sub.append(ElemDef)
         for sc in ElemDef.getSubclasses():
          if sc.isAbstract():
            continue
          sub.unionWith(getAllSubclasses(sc))
         return sub
        
        candidates=coral.Set()
        l=getAllSubclasses(L.TextGen)
        for element in l:
         candidates.append(element)
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
         newClass=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
         newClass=None
         return
                
        if newClass:
         o=newClass()
         setattr(o,"name","(noname)")
         focus.text.append(o)
         return o
    elementFactory = staticmethod(elementFactory)

from coral.addins.TEXTAGEN10.FolderGenPE import FolderGenPE

class FolderGenEditor(FolderGenPE,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        FolderGenPE.__init__(self,parent)
        self.setName("FolderGen")
        self.TargetEdit.setReadOnly(True)
        self.connect(self.dummyButton,SIGNAL('clicked()'),self.dummyButtonClicked)
        self.connect(self.pickED,SIGNAL('clicked()'),self.pickEDClicked)
        self.fieldTarget = None
        self.connect(self.DescriptionEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.folderNameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.folderNameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        FolderGenPE.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.FolderGen]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.match
        PropertyEditor.focusOn(self,element)
        self.TargetEdit.setText("")
        if element.match:
            self.TargetEdit.setText(getFQName(element.match,1))
            self.TargetEdit.setEdited(0)
        
        line,index=self.DescriptionEdit.getCursorPosition()
        self.DescriptionEdit.setText(unicode(element.description))
        self.DescriptionEdit.setCursorPosition(line,index)
        
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.folderNameEdit.setText(unicode(element.folderName))
        self.folderNameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            
            t=unicode(self.DescriptionEdit.text())
            self.focus.description=t
            
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.folderNameEdit.text())
            self.focus.folderName=t
            self.folderNameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def pickEDClicked(self):
        ed=self.focus.__type__().getPropertyByName("match").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.match=r
            self.TargetEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def dummyButtonClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            pass
        finally:
            coral.getTransactionManager().endModifyCmd()
            
from coral.addins.TEXTAGEN10.FileGenPE import FileGenPE

class FileGenEditor(FileGenPE,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        FileGenPE.__init__(self,parent)
        self.setName("FileGen")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('returnPressed()'),self.apply)
        self.TargetEdit.setReadOnly(True)
        self.connect(self.dummyButton,SIGNAL('clicked()'),self.dummyButtonClicked)
        self.connect(self.pickED,SIGNAL('clicked()'),self.pickEDClicked)
        self.fieldTarget = None
        self.connect(self.fileNameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.fileNameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.fileExtensionEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.fileExtensionEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        FileGenPE.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.FileGen]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.match
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.DescriptionEdit.getCursorPosition()
        self.DescriptionEdit.setText(unicode(element.description))
        self.DescriptionEdit.setCursorPosition(line,index)
        
        self.TargetEdit.setText("")
        if element.match:
            self.TargetEdit.setText(getFQName(element.match,1))
            self.TargetEdit.setEdited(0)
        
        self.fileNameEdit.setText(unicode(element.fileName))
        self.fileNameEdit.setEdited(0)
        
        self.fileExtensionEdit.setText(unicode(element.fileExtension))
        self.fileExtensionEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.DescriptionEdit.text())
            self.focus.description=t
            
            
            t=unicode(self.fileNameEdit.text())
            self.focus.fileName=t
            self.fileNameEdit.setEdited(0)
            
            t=unicode(self.fileExtensionEdit.text())
            self.focus.fileExtension=t
            self.fileExtensionEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def pickEDClicked(self):
        ed=self.focus.__type__().getPropertyByName("match").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.match=r
            self.TargetEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def dummyButtonClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            pass
        finally:
            coral.getTransactionManager().endModifyCmd()
            
