# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.UML14
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache
from util import *


class OperationEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Operation")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"specificationLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("specification:")
        self.SpecificationEdit=QTextEdit(self,"SpecificationEdit")
        self.SpecificationEdit.setGeometry(QRect(240,30,300,200))
        self.Label3= QLabel(self,"visibilityLabel")
        self.Label3.setGeometry(QRect(240,240,200,20))
        self.Label3.setText("visibility:")
        self.VisibilityComboBox=QComboBox(0,self,"VisibilityComboBox")
        self.VisibilityComboBox.setGeometry(QRect(240,260,200,20))
        self.setName("Operation")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.SpecificationEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.SpecificationEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.VisibilityComboBox,SIGNAL('activated(int)'),self.changed)
        self.connect(self.VisibilityComboBox,SIGNAL('activated(int)'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Operation]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.SpecificationEdit.getCursorPosition()
        self.SpecificationEdit.setText(unicode(element.specification))
        self.SpecificationEdit.setCursorPosition(line,index)
        
        self.VisibilityComboBox.clear()
        property = element.__type__().getPropertyByName("visibility")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.VisibilityComboBox.insertItem(ed.getDescription(i))
        self.VisibilityComboBox.setCurrentItem(element.visibility.__getEValue__())
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.SpecificationEdit.text())
            self.focus.specification=t
            
            self.focus.visibility=self.VisibilityComboBox.currentItem()
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class AttributesEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Attributes"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Classifier]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def filterAssociation(e):
        if e.oclIsKindOf(Attribute):
            return 1
        return 0
    filterAssociation = staticmethod(filterAssociation)

    def getSubEditors():
        return [AttributeEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "feature"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.feature,'attr')
        return L.Attribute(name=name)
    elementFactory = staticmethod(elementFactory)


class AttributeEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Attribute")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"typeLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("type:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.TypeEdit=ReferenceLineEdit(self,"TypeEdit")
        self.TypeEdit.setGeometry(QRect(20,80,200,20))
        noselect = False
        self.NewTypePushButton=QToolButton(self,"NewTypePushButton")
        self.NewTypePushButton.setGeometry(QRect(230,75,28,28))
        self.NewTypePushButton.setPixmap(iconcache.getIcon("newAction"))
        self.NewTypePushButton.setTextLabel("New Element")
        self.SelectTypePushButton=QToolButton(self,"SelectTypePushButton")
        if noselect:
            self.SelectTypePushButton.setGeometry(QRect(230,75,28,28))
        else:
            self.SelectTypePushButton.setGeometry(QRect(270,75,28,28))
        self.SelectTypePushButton.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectTypePushButton.setTextLabel("Select Element")
        self.Label3= QLabel(self,"visibilityLabel")
        self.Label3.setGeometry(QRect(20,110,200,20))
        self.Label3.setText("visibility:")
        self.VisibilityComboBox=QComboBox(0,self,"VisibilityComboBox")
        self.VisibilityComboBox.setGeometry(QRect(20,130,200,20))
        self.Label4= QLabel(self,"multiplicityLabel")
        self.Label4.setGeometry(QRect(310,10,200,20))
        self.Label4.setText("multiplicity:")
        self.MultiplicityEdit=QLineEdit(self,"MultiplicityEdit")
        self.MultiplicityEdit.setGeometry(QRect(310,30,200,20))
        self.Label5= QLabel(self,"orderingLabel")
        self.Label5.setGeometry(QRect(310,60,200,20))
        self.Label5.setText("ordering:")
        self.OrderingEdit=QComboBox(0,self,"OrderingEdit")
        self.OrderingEdit.setGeometry(QRect(310,80,200,20))
        self.Label6= QLabel(self,"changeabilityLabel")
        self.Label6.setGeometry(QRect(310,110,200,20))
        self.Label6.setText("changeability:")
        self.ChangeabilityComboBox=QComboBox(0,self,"ChangeabilityComboBox")
        self.ChangeabilityComboBox.setGeometry(QRect(310,130,200,20))
        self.Label7= QLabel(self,"initialValueLabel")
        self.Label7.setGeometry(QRect(310,160,200,20))
        self.Label7.setText("initialValue:")
        self.InitialValueEdit=QLineEdit(self,"InitialValueEdit")
        self.InitialValueEdit.setGeometry(QRect(310,180,200,20))
        self.setName("Attribute")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.TypeEdit.setReadOnly(True)
        self.connect(self.NewTypePushButton,SIGNAL('clicked()'),self.NewTypePushButtonClicked)
        self.connect(self.SelectTypePushButton,SIGNAL('clicked()'),self.SelectTypePushButtonClicked)
        self.fieldTarget = None
        self.connect(self.VisibilityComboBox,SIGNAL('activated(int)'),self.changed)
        self.connect(self.VisibilityComboBox,SIGNAL('activated(int)'),self.apply)
        self.connect(self.MultiplicityEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.MultiplicityEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.OrderingEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.OrderingEdit,SIGNAL('activated(int)'),self.apply)
        self.connect(self.ChangeabilityComboBox,SIGNAL('activated(int)'),self.changed)
        self.connect(self.ChangeabilityComboBox,SIGNAL('activated(int)'),self.apply)
        self.connect(self.InitialValueEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.InitialValueEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.Attribute]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.type
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.TypeEdit.setText("")
        if element.type:
            self.TypeEdit.setText(getFQName(element.type,1))
            self.TypeEdit.setEdited(0)
        
        self.VisibilityComboBox.clear()
        property = element.__type__().getPropertyByName("visibility")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.VisibilityComboBox.insertItem(ed.getDescription(i))
        self.VisibilityComboBox.setCurrentItem(element.visibility.__getEValue__())
        
        self.MultiplicityEdit.setText(fromMultiplicityToString(self.focus.multiplicity))
        self.MultiplicityEdit.setEdited(0)
        
        self.OrderingEdit.clear()
        property = element.__type__().getPropertyByName("ordering")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.OrderingEdit.insertItem(ed.getDescription(i))
        self.OrderingEdit.setCurrentItem(element.ordering.__getEValue__())
        
        self.ChangeabilityComboBox.clear()
        property = element.__type__().getPropertyByName("changeability")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.ChangeabilityComboBox.insertItem(ed.getDescription(i))
        self.ChangeabilityComboBox.setCurrentItem(element.changeability.__getEValue__())
        
        self.InitialValueEdit.setText("")
        if self.focus.initialValue:
        	self.InitialValueEdit.setText(unicode(element.initialValue.body))
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
            self.focus.visibility=self.VisibilityComboBox.currentItem()
            
            t=unicode(self.MultiplicityEdit.text())
            if t!="" and self.MultiplicityEdit.edited():
            	if fromStringToMultiplicity(t):
            		self.focus.multiplicity=fromStringToMultiplicity(t)
            
            self.focus.ordering=self.OrderingEdit.currentItem()
            
            self.focus.changeability=self.ChangeabilityComboBox.currentItem()
            
            t=unicode(self.InitialValueEdit.text())
            if t!="":
            	if not self.focus.initialValue:
            		self.focus.initialValue=Expression()
            	self.focus.initialValue.body=t
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectTypePushButtonClicked(self):
        ed=self.focus.__type__().getPropertyByName("type").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.type=r
            self.TypeEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewTypePushButtonClicked(self):
        newType = coral.lang.UML14.Class
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Package)
            parent.ownedElement.add(newElement)
            self.focus.type = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class OperationsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Operations"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Classifier]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def filterAssociation(e):
        if e.oclIsKindOf(Operation):
            return 1
        return 0
    filterAssociation = staticmethod(filterAssociation)

    def getSubEditors():
        return [OperationEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "feature"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.feature,'op')
        return L.Operation(name=name)
    elementFactory = staticmethod(elementFactory)


class ClassEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Class")
        self.Label1= QLabel(self,"visibilityLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("visibility:")
        self.VisibilityComboBox=QComboBox(0,self,"VisibilityComboBox")
        self.VisibilityComboBox.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"nameLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(240,30,200,20))
        self.Label3= QLabel(self,"isSpecificationLabel")
        self.Label3.setGeometry(QRect(240,60,200,20))
        self.Label3.setText("isSpecification:")
        self.SpecificationCheckBox=QCheckBox(self,"SpecificationCheckBox")
        self.SpecificationCheckBox.setGeometry(QRect(240,80,200,20))
        self.SpecificationCheckBox.setText("isSpecification")
        self.setName("Class")
        self.connect(self.VisibilityComboBox,SIGNAL('activated(int)'),self.changed)
        self.connect(self.VisibilityComboBox,SIGNAL('activated(int)'),self.apply)
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.SpecificationCheckBox,SIGNAL('clicked()'),self.changed)
        self.connect(self.SpecificationCheckBox,SIGNAL('clicked()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Class]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.VisibilityComboBox.clear()
        property = element.__type__().getPropertyByName("visibility")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.VisibilityComboBox.insertItem(ed.getDescription(i))
        self.VisibilityComboBox.setCurrentItem(element.visibility.__getEValue__())
        
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.SpecificationCheckBox.setChecked(element.isSpecification)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            self.focus.visibility=self.VisibilityComboBox.currentItem()
            
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            self.focus.isSpecification=self.SpecificationCheckBox.isChecked()
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class ParameterEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Parameter")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"kindLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("kind:")
        self.KindEdit=QComboBox(0,self,"KindEdit")
        self.KindEdit.setGeometry(QRect(20,80,200,20))
        self.Label3= QLabel(self,"typeLabel")
        self.Label3.setGeometry(QRect(240,10,200,20))
        self.Label3.setText("type:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.TypeEdit=ReferenceLineEdit(self,"TypeEdit")
        self.TypeEdit.setGeometry(QRect(240,30,200,20))
        noselect = False
        self.NewType=QToolButton(self,"NewType")
        self.NewType.setGeometry(QRect(450,25,28,28))
        self.NewType.setPixmap(iconcache.getIcon("newAction"))
        self.NewType.setTextLabel("New Element")
        self.SelectType=QToolButton(self,"SelectType")
        if noselect:
            self.SelectType.setGeometry(QRect(450,25,28,28))
        else:
            self.SelectType.setGeometry(QRect(490,25,28,28))
        self.SelectType.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectType.setTextLabel("Select Element")
        self.Label4= QLabel(self,"defaultValueLabel")
        self.Label4.setGeometry(QRect(240,60,200,20))
        self.Label4.setText("defaultValue:")
        self.DefaultValueEdit=QLineEdit(self,"DefaultValueEdit")
        self.DefaultValueEdit.setGeometry(QRect(240,80,200,20))
        self.setName("Parameter")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.KindEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.KindEdit,SIGNAL('activated(int)'),self.apply)
        self.TypeEdit.setReadOnly(True)
        self.connect(self.NewType,SIGNAL('clicked()'),self.NewTypeClicked)
        self.connect(self.SelectType,SIGNAL('clicked()'),self.SelectTypeClicked)
        self.fieldTarget = None
        self.connect(self.DefaultValueEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.DefaultValueEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.Parameter]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.type
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.KindEdit.clear()
        property = element.__type__().getPropertyByName("kind")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.KindEdit.insertItem(ed.getDescription(i))
        self.KindEdit.setCurrentItem(element.kind.__getEValue__())
        
        self.TypeEdit.setText("")
        if element.type:
            self.TypeEdit.setText(getFQName(element.type,1))
            self.TypeEdit.setEdited(0)
        
        self.DefaultValueEdit.setText("")
        if self.focus.defaultValue:
        	self.DefaultValueEdit.setText(unicode(element.defaultValue.body))
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            self.focus.kind=self.KindEdit.currentItem()
            
            
            t=unicode(self.DefaultValueEdit.text())
            if t!="":
            	if not self.focus.defaultValue:
            		self.focus.defaultValue=Expression()
            	self.focus.defaultValue.body=t
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectTypeClicked(self):
        ed=self.focus.__type__().getPropertyByName("type").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.type=r
            self.TypeEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewTypeClicked(self):
        prop=self.focus.__type__().getPropertyByName("type")
        candidates = coral.inheritanceTree(prop.getTarget())
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
            newType=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.type = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class ParametersEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Parameters"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.BehavioralFeature]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [ParameterEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "parameter"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.parameter,'para')
        return L.Parameter(name=name)
    elementFactory = staticmethod(elementFactory)


class MethodEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Method")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"visibilityLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("visibility:")
        self.VisibilityEdit=QComboBox(0,self,"VisibilityEdit")
        self.VisibilityEdit.setGeometry(QRect(20,80,200,20))
        self.Label3= QLabel(self,"bodyLabel")
        self.Label3.setGeometry(QRect(240,10,200,20))
        self.Label3.setText("body:")
        self.BodyEdit=QTextEdit(self,"BodyEdit")
        self.BodyEdit.setGeometry(QRect(240,30,300,200))
        self.Label4= QLabel(self,"ownerScopeLabel")
        self.Label4.setGeometry(QRect(240,240,200,20))
        self.Label4.setText("ownerScope:")
        self.OwnerScopeEdit=QComboBox(0,self,"OwnerScopeEdit")
        self.OwnerScopeEdit.setGeometry(QRect(240,260,200,20))
        self.setName("Method")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.VisibilityEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.VisibilityEdit,SIGNAL('activated(int)'),self.apply)
        self.connect(self.BodyEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.BodyEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.OwnerScopeEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.OwnerScopeEdit,SIGNAL('activated(int)'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Method]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.VisibilityEdit.clear()
        property = element.__type__().getPropertyByName("visibility")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.VisibilityEdit.insertItem(ed.getDescription(i))
        self.VisibilityEdit.setCurrentItem(element.visibility.__getEValue__())
        
        self.BodyEdit.setText("")
        if self.focus.body:
        	self.BodyEdit.setText(unicode(element.body.body))
        
        self.OwnerScopeEdit.clear()
        property = element.__type__().getPropertyByName("ownerScope")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.OwnerScopeEdit.insertItem(ed.getDescription(i))
        self.OwnerScopeEdit.setCurrentItem(element.ownerScope.__getEValue__())
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            self.focus.visibility=self.VisibilityEdit.currentItem()
            
            t=unicode(self.BodyEdit.text())
            if t!="":
            	if not self.focus.body:
            		self.focus.body=ProcedureExpression()
            	self.focus.body.body=t
            
            self.focus.ownerScope=self.OwnerScopeEdit.currentItem()
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class MethodsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Methods"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Classifier]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def filterAssociation(e):
        if e.oclIsKindOf(Method):
            return 1
        return 0
    filterAssociation = staticmethod(filterAssociation)

    def getSubEditors():
        return [MethodEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "feature"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.feature,'method')
        return L.Method(name=name)
    elementFactory = staticmethod(elementFactory)


class StateEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("State")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"entryLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("entry:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.EntryEdit=ReferenceLineEdit(self,"EntryEdit")
        self.EntryEdit.setGeometry(QRect(20,80,200,20))
        noselect = False
        self.NewEntry=QToolButton(self,"NewEntry")
        self.NewEntry.setGeometry(QRect(230,75,28,28))
        self.NewEntry.setPixmap(iconcache.getIcon("newAction"))
        self.NewEntry.setTextLabel("New Element")
        association = False
        for mc in [L.State]:
            if mc.getPropertyByName("entry") and mc.getPropertyByName("entry").isAssociation():
                association = True
                self.NewEntry.setHidden(True)
                noselect = True
                break
        self.SelectEntry=QToolButton(self,"SelectEntry")
        if noselect:
            self.SelectEntry.setGeometry(QRect(230,75,28,28))
        else:
            self.SelectEntry.setGeometry(QRect(270,75,28,28))
        self.SelectEntry.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectEntry.setTextLabel("Select Element")
        self.Label3= QLabel(self,"exitLabel")
        self.Label3.setGeometry(QRect(310,10,200,20))
        self.Label3.setText("exit:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ExitEdit=ReferenceLineEdit(self,"ExitEdit")
        self.ExitEdit.setGeometry(QRect(310,30,200,20))
        noselect = False
        self.NewExit=QToolButton(self,"NewExit")
        self.NewExit.setGeometry(QRect(520,25,28,28))
        self.NewExit.setPixmap(iconcache.getIcon("newAction"))
        self.NewExit.setTextLabel("New Element")
        association = False
        for mc in [L.State]:
            if mc.getPropertyByName("exit") and mc.getPropertyByName("exit").isAssociation():
                association = True
                self.NewExit.setHidden(True)
                noselect = True
                break
        self.SelectExit=QToolButton(self,"SelectExit")
        if noselect:
            self.SelectExit.setGeometry(QRect(520,25,28,28))
        else:
            self.SelectExit.setGeometry(QRect(560,25,28,28))
        self.SelectExit.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectExit.setTextLabel("Select Element")
        self.Label4= QLabel(self,"doActivityLabel")
        self.Label4.setGeometry(QRect(310,60,200,20))
        self.Label4.setText("doActivity:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.DoActivityEdit=ReferenceLineEdit(self,"DoActivityEdit")
        self.DoActivityEdit.setGeometry(QRect(310,80,200,20))
        noselect = False
        self.NewActivity=QToolButton(self,"NewActivity")
        self.NewActivity.setGeometry(QRect(520,75,28,28))
        self.NewActivity.setPixmap(iconcache.getIcon("newAction"))
        self.NewActivity.setTextLabel("New Element")
        association = False
        for mc in [L.State]:
            if mc.getPropertyByName("doActivity") and mc.getPropertyByName("doActivity").isAssociation():
                association = True
                self.NewActivity.setHidden(True)
                noselect = True
                break
        self.SelectActivity=QToolButton(self,"SelectActivity")
        if noselect:
            self.SelectActivity.setGeometry(QRect(520,75,28,28))
        else:
            self.SelectActivity.setGeometry(QRect(560,75,28,28))
        self.SelectActivity.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectActivity.setTextLabel("Select Element")
        self.setName("State")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.EntryEdit.setReadOnly(True)
        self.connect(self.NewEntry,SIGNAL('clicked()'),self.NewEntryClicked)
        self.connect(self.SelectEntry,SIGNAL('clicked()'),self.SelectEntryClicked)
        self.fieldTarget = None
        self.ExitEdit.setReadOnly(True)
        self.connect(self.NewExit,SIGNAL('clicked()'),self.NewExitClicked)
        self.connect(self.SelectExit,SIGNAL('clicked()'),self.SelectExitClicked)
        self.fieldTarget = None
        self.DoActivityEdit.setReadOnly(True)
        self.connect(self.NewActivity,SIGNAL('clicked()'),self.NewActivityClicked)
        self.connect(self.SelectActivity,SIGNAL('clicked()'),self.SelectActivityClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.State]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.entry
        self.fieldTarget=element.exit
        self.fieldTarget=element.doActivity
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.EntryEdit.setText("")
        if element.entry:
            self.EntryEdit.setText(getFQName(element.entry,1))
            self.EntryEdit.setEdited(0)
        
        self.ExitEdit.setText("")
        if element.exit:
            self.ExitEdit.setText(getFQName(element.exit,1))
            self.ExitEdit.setEdited(0)
        
        self.DoActivityEdit.setText("")
        if element.doActivity:
            self.DoActivityEdit.setText(getFQName(element.doActivity,1))
            self.DoActivityEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectEntryClicked(self):
        ed=self.focus.__type__().getPropertyByName("entry").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.entry=r
            self.EntryEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewEntryClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("entry")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectExitClicked(self):
        ed=self.focus.__type__().getPropertyByName("exit").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.exit=r
            self.ExitEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewExitClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("exit")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectActivityClicked(self):
        ed=self.focus.__type__().getPropertyByName("doActivity").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.doActivity=r
            self.DoActivityEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewActivityClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("doActivity")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class CommentEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Comment")
        self.Label1= QLabel(self,"bodyLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("body:")
        self.BodyEdit=QTextEdit(self,"BodyEdit")
        self.BodyEdit.setGeometry(QRect(40,30,300,200))
        self.setName("Comment")
        self.connect(self.BodyEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.BodyEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Comment]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        line,index=self.BodyEdit.getCursorPosition()
        self.BodyEdit.setText(unicode(element.body))
        self.BodyEdit.setCursorPosition(line,index)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.BodyEdit.text())
            self.focus.body=t
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class AssociationEndEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("AssociationEnd")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"multiplicityLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("multiplicity:")
        self.MultiplicityEdit=QLineEdit(self,"MultiplicityEdit")
        self.MultiplicityEdit.setGeometry(QRect(20,80,200,20))
        self.Label3= QLabel(self,"orderingLabel")
        self.Label3.setGeometry(QRect(20,110,200,20))
        self.Label3.setText("ordering:")
        self.OrderingEdit=QComboBox(0,self,"OrderingEdit")
        self.OrderingEdit.setGeometry(QRect(20,130,200,20))
        self.Label4= QLabel(self,"changeabilityLabel")
        self.Label4.setGeometry(QRect(20,160,200,20))
        self.Label4.setText("changeability:")
        self.ChangeabilityEdit=QComboBox(0,self,"ChangeabilityEdit")
        self.ChangeabilityEdit.setGeometry(QRect(20,180,200,20))
        self.Label5= QLabel(self,"aggregationLabel")
        self.Label5.setGeometry(QRect(240,10,200,20))
        self.Label5.setText("aggregation:")
        self.AggregationEdit=QComboBox(0,self,"AggregationEdit")
        self.AggregationEdit.setGeometry(QRect(240,30,200,20))
        self.Label6= QLabel(self,"targetScopeLabel")
        self.Label6.setGeometry(QRect(240,60,200,20))
        self.Label6.setText("targetScope:")
        self.TargetScopeEdit=QComboBox(0,self,"TargetScopeEdit")
        self.TargetScopeEdit.setGeometry(QRect(240,80,200,20))
        self.Label7= QLabel(self,"visibilityLabel")
        self.Label7.setGeometry(QRect(240,110,200,20))
        self.Label7.setText("visibility:")
        self.VisibilityEdit=QComboBox(0,self,"VisibilityEdit")
        self.VisibilityEdit.setGeometry(QRect(240,130,200,20))
        self.Label8= QLabel(self,"isNavigableLabel")
        self.Label8.setGeometry(QRect(240,160,200,20))
        self.Label8.setText("isNavigable:")
        self.IsNavigableEdit=QCheckBox(self,"IsNavigableEdit")
        self.IsNavigableEdit.setGeometry(QRect(240,180,200,20))
        self.IsNavigableEdit.setText("isNavigable")
        self.Label9= QLabel(self,"participantLabel")
        self.Label9.setGeometry(QRect(240,210,200,20))
        self.Label9.setText("participant:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ParticipantEdit=ReferenceLineEdit(self,"ParticipantEdit")
        self.ParticipantEdit.setGeometry(QRect(240,230,200,20))
        noselect = False
        self.NewParticipant=QToolButton(self,"NewParticipant")
        self.NewParticipant.setGeometry(QRect(450,225,28,28))
        self.NewParticipant.setPixmap(iconcache.getIcon("newAction"))
        self.NewParticipant.setTextLabel("New Element")
        self.SelectParticipant=QToolButton(self,"SelectParticipant")
        if noselect:
            self.SelectParticipant.setGeometry(QRect(450,225,28,28))
        else:
            self.SelectParticipant.setGeometry(QRect(490,225,28,28))
        self.SelectParticipant.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectParticipant.setTextLabel("Select Element")
        self.setName("AssociationEnd")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.MultiplicityEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.MultiplicityEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.OrderingEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.OrderingEdit,SIGNAL('activated(int)'),self.apply)
        self.connect(self.ChangeabilityEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.ChangeabilityEdit,SIGNAL('activated(int)'),self.apply)
        self.connect(self.AggregationEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.AggregationEdit,SIGNAL('activated(int)'),self.apply)
        self.connect(self.TargetScopeEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.TargetScopeEdit,SIGNAL('activated(int)'),self.apply)
        self.connect(self.VisibilityEdit,SIGNAL('activated(int)'),self.changed)
        self.connect(self.VisibilityEdit,SIGNAL('activated(int)'),self.apply)
        self.connect(self.IsNavigableEdit,SIGNAL('clicked()'),self.changed)
        self.connect(self.IsNavigableEdit,SIGNAL('clicked()'),self.apply)
        self.ParticipantEdit.setReadOnly(True)
        self.connect(self.NewParticipant,SIGNAL('clicked()'),self.NewParticipantClicked)
        self.connect(self.SelectParticipant,SIGNAL('clicked()'),self.SelectParticipantClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.AssociationEnd]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.participant
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.MultiplicityEdit.setText(fromMultiplicityToString(self.focus.multiplicity))
        self.MultiplicityEdit.setEdited(0)
        
        self.OrderingEdit.clear()
        property = element.__type__().getPropertyByName("ordering")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.OrderingEdit.insertItem(ed.getDescription(i))
        self.OrderingEdit.setCurrentItem(element.ordering.__getEValue__())
        
        self.ChangeabilityEdit.clear()
        property = element.__type__().getPropertyByName("changeability")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.ChangeabilityEdit.insertItem(ed.getDescription(i))
        self.ChangeabilityEdit.setCurrentItem(element.changeability.__getEValue__())
        
        self.AggregationEdit.clear()
        property = element.__type__().getPropertyByName("aggregation")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.AggregationEdit.insertItem(ed.getDescription(i))
        self.AggregationEdit.setCurrentItem(element.aggregation.__getEValue__())
        
        self.TargetScopeEdit.clear()
        property = element.__type__().getPropertyByName("targetScope")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.TargetScopeEdit.insertItem(ed.getDescription(i))
        self.TargetScopeEdit.setCurrentItem(element.targetScope.__getEValue__())
        
        self.VisibilityEdit.clear()
        property = element.__type__().getPropertyByName("visibility")
        ed = property.getTarget()
        size = ed.size()
        for i in xrange(size):
            self.VisibilityEdit.insertItem(ed.getDescription(i))
        self.VisibilityEdit.setCurrentItem(element.visibility.__getEValue__())
        
        self.IsNavigableEdit.setChecked(element.isNavigable)
        
        self.ParticipantEdit.setText("")
        if element.participant:
            self.ParticipantEdit.setText(getFQName(element.participant,1))
            self.ParticipantEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.MultiplicityEdit.text())
            if t!="" and self.MultiplicityEdit.edited():
            	if fromStringToMultiplicity(t):
            		self.focus.multiplicity=fromStringToMultiplicity(t)
            
            self.focus.ordering=self.OrderingEdit.currentItem()
            
            self.focus.changeability=self.ChangeabilityEdit.currentItem()
            
            self.focus.aggregation=self.AggregationEdit.currentItem()
            
            self.focus.targetScope=self.TargetScopeEdit.currentItem()
            
            self.focus.visibility=self.VisibilityEdit.currentItem()
            
            self.focus.isNavigable=self.IsNavigableEdit.isChecked()
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectParticipantClicked(self):
        ed=self.focus.__type__().getPropertyByName("participant").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.participant=r
            self.ParticipantEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewParticipantClicked(self):
        prop=self.focus.__type__().getPropertyByName("participant")
        candidates = coral.inheritanceTree(prop.getTarget())
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
            newType=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Package)
            parent.ownedElement.add(newElement)
            self.focus.participant = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class AssociationEndsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "AssociationEnds"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Association]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [AssociationEndEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "connection"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.connection,'AssociationEnd')
        return L.AssociationEnd(name=name)
    elementFactory = staticmethod(elementFactory)


class QualifiersEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Qualifiers"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.AssociationEnd]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [AttributeEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "qualifier"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.qualifier,'attr')
        return L.Attribute(name=name)
    elementFactory = staticmethod(elementFactory)


class AssociationEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Association")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("Association")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Association]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class PackageEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Package")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("Package")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Package]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class TimeEventEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("TimeEvent")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"whenLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("when:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.WhenEdit=ReferenceLineEdit(self,"WhenEdit")
        self.WhenEdit.setGeometry(QRect(240,30,200,20))
        noselect = False
        self.NewWhen=QToolButton(self,"NewWhen")
        self.NewWhen.setGeometry(QRect(450,25,28,28))
        self.NewWhen.setPixmap(iconcache.getIcon("newAction"))
        self.NewWhen.setTextLabel("New Element")
        association = False
        for mc in [L.TimeEvent]:
            if mc.getPropertyByName("when") and mc.getPropertyByName("when").isAssociation():
                association = True
                self.NewWhen.setHidden(True)
                noselect = True
                break
        self.SelectWhen=QToolButton(self,"SelectWhen")
        if noselect:
            self.SelectWhen.setGeometry(QRect(450,25,28,28))
        else:
            self.SelectWhen.setGeometry(QRect(490,25,28,28))
        self.SelectWhen.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectWhen.setTextLabel("Select Element")
        self.setName("TimeEvent")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.WhenEdit.setReadOnly(True)
        self.connect(self.NewWhen,SIGNAL('clicked()'),self.NewWhenClicked)
        self.connect(self.SelectWhen,SIGNAL('clicked()'),self.SelectWhenClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.TimeEvent]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.when
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.WhenEdit.setText("")
        if element.when:
            self.WhenEdit.setText(getFQName(element.when,1))
            self.WhenEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectWhenClicked(self):
        ed=self.focus.__type__().getPropertyByName("when").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.when=r
            self.WhenEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewWhenClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("when")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class ChangeEventEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("ChangeEvent")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"changeExpressionLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("changeExpression:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ChangeExpressionEdit=ReferenceLineEdit(self,"ChangeExpressionEdit")
        self.ChangeExpressionEdit.setGeometry(QRect(240,30,200,20))
        noselect = False
        self.NewChangeExpression=QToolButton(self,"NewChangeExpression")
        self.NewChangeExpression.setGeometry(QRect(450,25,28,28))
        self.NewChangeExpression.setPixmap(iconcache.getIcon("newAction"))
        self.NewChangeExpression.setTextLabel("New Element")
        association = False
        for mc in [L.ChangeEvent]:
            if mc.getPropertyByName("changeExpression") and mc.getPropertyByName("changeExpression").isAssociation():
                association = True
                self.NewChangeExpression.setHidden(True)
                noselect = True
                break
        self.SelectChangeExpression=QToolButton(self,"SelectChangeExpression")
        if noselect:
            self.SelectChangeExpression.setGeometry(QRect(450,25,28,28))
        else:
            self.SelectChangeExpression.setGeometry(QRect(490,25,28,28))
        self.SelectChangeExpression.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectChangeExpression.setTextLabel("Select Element")
        self.setName("ChangeEvent")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.ChangeExpressionEdit.setReadOnly(True)
        self.connect(self.NewChangeExpression,SIGNAL('clicked()'),self.NewChangeExpressionClicked)
        self.connect(self.SelectChangeExpression,SIGNAL('clicked()'),self.SelectChangeExpressionClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.ChangeEvent]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.changeExpression
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.ChangeExpressionEdit.setText("")
        if element.changeExpression:
            self.ChangeExpressionEdit.setText(getFQName(element.changeExpression,1))
            self.ChangeExpressionEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectChangeExpressionClicked(self):
        ed=self.focus.__type__().getPropertyByName("changeExpression").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.changeExpression=r
            self.ChangeExpressionEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewChangeExpressionClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("changeExpression")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class TransitionEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Transition")
        self.Label1= QLabel(self,"guardLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("guard:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.GuardEdit=ReferenceLineEdit(self,"GuardEdit")
        self.GuardEdit.setGeometry(QRect(20,30,200,20))
        noselect = False
        self.NewGuard=QToolButton(self,"NewGuard")
        self.NewGuard.setGeometry(QRect(230,25,28,28))
        self.NewGuard.setPixmap(iconcache.getIcon("newAction"))
        self.NewGuard.setTextLabel("New Element")
        association = False
        for mc in [L.Transition]:
            if mc.getPropertyByName("guard") and mc.getPropertyByName("guard").isAssociation():
                association = True
                self.NewGuard.setHidden(True)
                noselect = True
                break
        self.SelectGuard=QToolButton(self,"SelectGuard")
        if noselect:
            self.SelectGuard.setGeometry(QRect(230,25,28,28))
        else:
            self.SelectGuard.setGeometry(QRect(270,25,28,28))
        self.SelectGuard.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectGuard.setTextLabel("Select Element")
        self.Label2= QLabel(self,"triggerLabel")
        self.Label2.setGeometry(QRect(310,10,200,20))
        self.Label2.setText("trigger:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.TriggerEdit=ReferenceLineEdit(self,"TriggerEdit")
        self.TriggerEdit.setGeometry(QRect(310,30,200,20))
        noselect = False
        self.NewTrigger=QToolButton(self,"NewTrigger")
        self.NewTrigger.setGeometry(QRect(520,25,28,28))
        self.NewTrigger.setPixmap(iconcache.getIcon("newAction"))
        self.NewTrigger.setTextLabel("New Element")
        self.SelectTrigger=QToolButton(self,"SelectTrigger")
        if noselect:
            self.SelectTrigger.setGeometry(QRect(520,25,28,28))
        else:
            self.SelectTrigger.setGeometry(QRect(560,25,28,28))
        self.SelectTrigger.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectTrigger.setTextLabel("Select Element")
        self.Label3= QLabel(self,"effectLabel")
        self.Label3.setGeometry(QRect(310,60,200,20))
        self.Label3.setText("effect:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.EffectEdit=ReferenceLineEdit(self,"EffectEdit")
        self.EffectEdit.setGeometry(QRect(310,80,200,20))
        noselect = False
        self.NewEffect=QToolButton(self,"NewEffect")
        self.NewEffect.setGeometry(QRect(520,75,28,28))
        self.NewEffect.setPixmap(iconcache.getIcon("newAction"))
        self.NewEffect.setTextLabel("New Element")
        association = False
        for mc in [L.Transition]:
            if mc.getPropertyByName("effect") and mc.getPropertyByName("effect").isAssociation():
                association = True
                self.NewEffect.setHidden(True)
                noselect = True
                break
        self.SelectEffect=QToolButton(self,"SelectEffect")
        if noselect:
            self.SelectEffect.setGeometry(QRect(520,75,28,28))
        else:
            self.SelectEffect.setGeometry(QRect(560,75,28,28))
        self.SelectEffect.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectEffect.setTextLabel("Select Element")
        self.setName("Transition")
        self.GuardEdit.setReadOnly(True)
        self.connect(self.NewGuard,SIGNAL('clicked()'),self.NewGuardClicked)
        self.connect(self.SelectGuard,SIGNAL('clicked()'),self.SelectGuardClicked)
        self.fieldTarget = None
        self.TriggerEdit.setReadOnly(True)
        self.connect(self.NewTrigger,SIGNAL('clicked()'),self.NewTriggerClicked)
        self.connect(self.SelectTrigger,SIGNAL('clicked()'),self.SelectTriggerClicked)
        self.fieldTarget = None
        self.EffectEdit.setReadOnly(True)
        self.connect(self.NewEffect,SIGNAL('clicked()'),self.NewEffectClicked)
        self.connect(self.SelectEffect,SIGNAL('clicked()'),self.SelectEffectClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.Transition]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.guard
        self.fieldTarget=element.trigger
        self.fieldTarget=element.effect
        PropertyEditor.focusOn(self,element)
        self.GuardEdit.setText("")
        if element.guard:
            self.GuardEdit.setText(getFQName(element.guard,1))
            self.GuardEdit.setEdited(0)
        
        self.TriggerEdit.setText("")
        if element.trigger:
            self.TriggerEdit.setText(getFQName(element.trigger,1))
            self.TriggerEdit.setEdited(0)
        
        self.EffectEdit.setText("")
        if element.effect:
            self.EffectEdit.setText(getFQName(element.effect,1))
            self.EffectEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectGuardClicked(self):
        ed=self.focus.__type__().getPropertyByName("guard").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.guard=r
            self.GuardEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewGuardClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("guard")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectTriggerClicked(self):
        ed=self.focus.__type__().getPropertyByName("trigger").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.trigger=r
            self.TriggerEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewTriggerClicked(self):
        prop=self.focus.__type__().getPropertyByName("trigger")
        candidates = coral.inheritanceTree(prop.getTarget())
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
            newType=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.trigger = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectEffectClicked(self):
        ed=self.focus.__type__().getPropertyByName("effect").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.effect=r
            self.EffectEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewEffectClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("effect")
            asslist=AssociationListE(self.editorSet, self.parent(),prop,self.focus,self.manager)
            asslist.show()
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class SignalEventEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("SignalEvent")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"signalLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("signal:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.SignalEdit=ReferenceLineEdit(self,"SignalEdit")
        self.SignalEdit.setGeometry(QRect(240,30,200,20))
        noselect = False
        self.NewSignal=QToolButton(self,"NewSignal")
        self.NewSignal.setGeometry(QRect(450,25,28,28))
        self.NewSignal.setPixmap(iconcache.getIcon("newAction"))
        self.NewSignal.setTextLabel("New Element")
        self.SelectSignal=QToolButton(self,"SelectSignal")
        if noselect:
            self.SelectSignal.setGeometry(QRect(450,25,28,28))
        else:
            self.SelectSignal.setGeometry(QRect(490,25,28,28))
        self.SelectSignal.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectSignal.setTextLabel("Select Element")
        self.setName("SignalEvent")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.SignalEdit.setReadOnly(True)
        self.connect(self.NewSignal,SIGNAL('clicked()'),self.NewSignalClicked)
        self.connect(self.SelectSignal,SIGNAL('clicked()'),self.SelectSignalClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.SignalEvent]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.signal
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.SignalEdit.setText("")
        if element.signal:
            self.SignalEdit.setText(getFQName(element.signal,1))
            self.SignalEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectSignalClicked(self):
        ed=self.focus.__type__().getPropertyByName("signal").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.signal=r
            self.SignalEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewSignalClicked(self):
        newType = coral.lang.UML14.Signal
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.signal = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class CallEventEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("CallEvent")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"operationLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("operation:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.OperationEdit=ReferenceLineEdit(self,"OperationEdit")
        self.OperationEdit.setGeometry(QRect(240,30,200,20))
        noselect = False
        self.NewOperation=QToolButton(self,"NewOperation")
        self.NewOperation.setGeometry(QRect(450,25,28,28))
        self.NewOperation.setPixmap(iconcache.getIcon("newAction"))
        self.NewOperation.setTextLabel("New Element")
        self.SelectOperation=QToolButton(self,"SelectOperation")
        if noselect:
            self.SelectOperation.setGeometry(QRect(450,25,28,28))
        else:
            self.SelectOperation.setGeometry(QRect(490,25,28,28))
        self.SelectOperation.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectOperation.setTextLabel("Select Element")
        self.setName("CallEvent")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.OperationEdit.setReadOnly(True)
        self.connect(self.NewOperation,SIGNAL('clicked()'),self.NewOperationClicked)
        self.connect(self.SelectOperation,SIGNAL('clicked()'),self.SelectOperationClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.CallEvent]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.operation
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.OperationEdit.setText("")
        if element.operation:
            self.OperationEdit.setText(getFQName(element.operation,1))
            self.OperationEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectOperationClicked(self):
        ed=self.focus.__type__().getPropertyByName("operation").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.operation=r
            self.OperationEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewOperationClicked(self):
        newType = coral.lang.UML14.Operation
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.operation = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class InternalTransitionsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "InternalTransitions"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.State]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [TransitionEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "internalTransition"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.internalTransition,'trans')
        return L.Transition(name=name)
    elementFactory = staticmethod(elementFactory)


class SubsystemEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Subsystem")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"isInstantiableLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("isInstantiable:")
        self.IsInstantiableEdit=QCheckBox(self,"IsInstantiableEdit")
        self.IsInstantiableEdit.setGeometry(QRect(240,30,200,20))
        self.IsInstantiableEdit.setText("isInstantiable")
        self.setName("Subsystem")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.IsInstantiableEdit,SIGNAL('clicked()'),self.changed)
        self.connect(self.IsInstantiableEdit,SIGNAL('clicked()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Subsystem]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.IsInstantiableEdit.setChecked(element.isInstantiable)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            self.focus.isInstantiable=self.IsInstantiableEdit.isChecked()
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class TaggedValueEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("TaggedValue")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"dataValueLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("dataValue:")
        self.DataValueEdit=QTextEdit(self,"DataValueEdit")
        self.DataValueEdit.setGeometry(QRect(240,30,300,200))
        self.setName("TaggedValue")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.DataValueEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.DataValueEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.TaggedValue]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.DataValueEdit.getCursorPosition()
        self.DataValueEdit.setText(unicode(element.dataValue))
        self.DataValueEdit.setCursorPosition(line,index)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.DataValueEdit.text())
            self.focus.dataValue=t
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class TaggedValuesEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "TaggedValues"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.ModelElement]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [TaggedValueEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "taggedValue"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.taggedValue,'taggedValue')
        return L.TaggedValue(name=name)
    elementFactory = staticmethod(elementFactory)


class TagDefinitonEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("TagDefiniton")
        self.Label1= QLabel(self,"tagTypeLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("tagType:")
        self.TagTypeEdit=QLineEdit(self,"TagTypeEdit")
        self.TagTypeEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"multiplicityLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("multiplicity:")
        self.MultiplicityEdit=QLineEdit(self,"MultiplicityEdit")
        self.MultiplicityEdit.setGeometry(QRect(240,30,200,20))
        self.setName("TagDefiniton")
        self.connect(self.TagTypeEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.TagTypeEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.MultiplicityEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.MultiplicityEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.TagDefinition]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.TagTypeEdit.setText(unicode(element.tagType))
        self.TagTypeEdit.setEdited(0)
        
        self.MultiplicityEdit.setText(fromMultiplicityToString(self.focus.multiplicity))
        self.MultiplicityEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.TagTypeEdit.text())
            self.focus.tagType=t
            self.TagTypeEdit.setEdited(0)
            
            t=unicode(self.MultiplicityEdit.text())
            if t!="" and self.MultiplicityEdit.edited():
            	if fromStringToMultiplicity(t):
            		self.focus.multiplicity=fromStringToMultiplicity(t)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class StereotypeEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Stereotype")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("Stereotype")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Stereotype]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class StereotypesEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Stereotypes"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.ModelElement]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [StereotypeEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "stereotype"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.stereotype,'stereotype')
        st=L.Stereotype(name=name)
        root=focus.__getRoot__()
        root.ownedElement.append(st)
        return st
    elementFactory = staticmethod(elementFactory)


class OwnedElementsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "OwnedElements"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Package,L.Collaboration]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [CollaborationEditor,ClassEditor,AssociationEditor,GeneralizationEditor,CommentEditor,StimulusEditor,ObjectEditor,PackageEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "ownedElement"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        candidates=coral.Set()
        l=focus.__type__().__language__()
        for element in l.__elements__():
        	candidates.append(element)
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
        	newClass=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
        	newClass=None
        	return
                
        if newClass:
        	o=newClass()
        	setattr(o,"name","(noname)")
        	focus.ownedElement.append(o)
        	return o
    elementFactory = staticmethod(elementFactory)


class GeneralizationEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Generalization")
        self.Label1= QLabel(self,"childLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("child:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ChildEdit=ReferenceLineEdit(self,"ChildEdit")
        self.ChildEdit.setGeometry(QRect(20,30,200,20))
        noselect = False
        self.NewChild=QToolButton(self,"NewChild")
        self.NewChild.setGeometry(QRect(230,25,28,28))
        self.NewChild.setPixmap(iconcache.getIcon("newAction"))
        self.NewChild.setTextLabel("New Element")
        self.SelectChild=QToolButton(self,"SelectChild")
        if noselect:
            self.SelectChild.setGeometry(QRect(230,25,28,28))
        else:
            self.SelectChild.setGeometry(QRect(270,25,28,28))
        self.SelectChild.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectChild.setTextLabel("Select Element")
        self.Label2= QLabel(self,"parentLabel")
        self.Label2.setGeometry(QRect(310,10,200,20))
        self.Label2.setText("parent:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ParentEdit=ReferenceLineEdit(self,"ParentEdit")
        self.ParentEdit.setGeometry(QRect(310,30,200,20))
        noselect = False
        self.NewParent=QToolButton(self,"NewParent")
        self.NewParent.setGeometry(QRect(520,25,28,28))
        self.NewParent.setPixmap(iconcache.getIcon("newAction"))
        self.NewParent.setTextLabel("New Element")
        self.SelectParent=QToolButton(self,"SelectParent")
        if noselect:
            self.SelectParent.setGeometry(QRect(520,25,28,28))
        else:
            self.SelectParent.setGeometry(QRect(560,25,28,28))
        self.SelectParent.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectParent.setTextLabel("Select Element")
        self.setName("Generalization")
        self.ChildEdit.setReadOnly(True)
        self.connect(self.NewChild,SIGNAL('clicked()'),self.NewChildClicked)
        self.connect(self.SelectChild,SIGNAL('clicked()'),self.SelectChildClicked)
        self.fieldTarget = None
        self.ParentEdit.setReadOnly(True)
        self.connect(self.NewParent,SIGNAL('clicked()'),self.NewParentClicked)
        self.connect(self.SelectParent,SIGNAL('clicked()'),self.SelectParentClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.Generalization]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.child
        self.fieldTarget=element.parent
        PropertyEditor.focusOn(self,element)
        self.ChildEdit.setText("")
        if element.child:
            self.ChildEdit.setText(getFQName(element.child,1))
            self.ChildEdit.setEdited(0)
        
        self.ParentEdit.setText("")
        if element.parent:
            self.ParentEdit.setText(getFQName(element.parent,1))
            self.ParentEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectChildClicked(self):
        ed=self.focus.__type__().getPropertyByName("child").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.child=r
            self.ChildEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewChildClicked(self):
        prop=self.focus.__type__().getPropertyByName("child")
        candidates = coral.inheritanceTree(prop.getTarget())
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
            newType=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.child = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectParentClicked(self):
        ed=self.focus.__type__().getPropertyByName("parent").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.parent=r
            self.ParentEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewParentClicked(self):
        prop=self.focus.__type__().getPropertyByName("parent")
        candidates = coral.inheritanceTree(prop.getTarget())
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
            newType=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.parent = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class StimulusEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Stimulus")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"senderLabel")
        self.Label2.setGeometry(QRect(20,60,200,20))
        self.Label2.setText("sender:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.SenderEdit=ReferenceLineEdit(self,"SenderEdit")
        self.SenderEdit.setGeometry(QRect(20,80,200,20))
        noselect = False
        self.newSender=QToolButton(self,"newSender")
        self.newSender.setGeometry(QRect(230,75,28,28))
        self.newSender.setPixmap(iconcache.getIcon("newAction"))
        self.newSender.setTextLabel("New Element")
        self.selectSender=QToolButton(self,"selectSender")
        if noselect:
            self.selectSender.setGeometry(QRect(230,75,28,28))
        else:
            self.selectSender.setGeometry(QRect(270,75,28,28))
        self.selectSender.setPixmap(iconcache.getIcon("linkAction"))
        self.selectSender.setTextLabel("Select Element")
        self.Label3= QLabel(self,"receiverLabel")
        self.Label3.setGeometry(QRect(310,10,200,20))
        self.Label3.setText("receiver:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.ReceiverEdit=ReferenceLineEdit(self,"ReceiverEdit")
        self.ReceiverEdit.setGeometry(QRect(310,30,200,20))
        noselect = False
        self.NewReceiver=QToolButton(self,"NewReceiver")
        self.NewReceiver.setGeometry(QRect(520,25,28,28))
        self.NewReceiver.setPixmap(iconcache.getIcon("newAction"))
        self.NewReceiver.setTextLabel("New Element")
        self.SelectReceiver=QToolButton(self,"SelectReceiver")
        if noselect:
            self.SelectReceiver.setGeometry(QRect(520,25,28,28))
        else:
            self.SelectReceiver.setGeometry(QRect(560,25,28,28))
        self.SelectReceiver.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectReceiver.setTextLabel("Select Element")
        self.Label4= QLabel(self,"dispatchActionLabel")
        self.Label4.setGeometry(QRect(310,60,200,20))
        self.Label4.setText("dispatchAction:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.DispatchActionEdit=ReferenceLineEdit(self,"DispatchActionEdit")
        self.DispatchActionEdit.setGeometry(QRect(310,80,200,20))
        noselect = False
        self.NewDispatchAction=QToolButton(self,"NewDispatchAction")
        self.NewDispatchAction.setGeometry(QRect(520,75,28,28))
        self.NewDispatchAction.setPixmap(iconcache.getIcon("newAction"))
        self.NewDispatchAction.setTextLabel("New Element")
        self.SelectDispatchAction=QToolButton(self,"SelectDispatchAction")
        if noselect:
            self.SelectDispatchAction.setGeometry(QRect(520,75,28,28))
        else:
            self.SelectDispatchAction.setGeometry(QRect(560,75,28,28))
        self.SelectDispatchAction.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectDispatchAction.setTextLabel("Select Element")
        self.Label5= QLabel(self,"communicationLinkLabel")
        self.Label5.setGeometry(QRect(310,110,200,20))
        self.Label5.setText("communicationLink:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.CommunicationLinkEdit=ReferenceLineEdit(self,"CommunicationLinkEdit")
        self.CommunicationLinkEdit.setGeometry(QRect(310,130,200,20))
        noselect = False
        self.NewCommunicationLink=QToolButton(self,"NewCommunicationLink")
        self.NewCommunicationLink.setGeometry(QRect(520,125,28,28))
        self.NewCommunicationLink.setPixmap(iconcache.getIcon("newAction"))
        self.NewCommunicationLink.setTextLabel("New Element")
        self.SelectCommunicationLink=QToolButton(self,"SelectCommunicationLink")
        if noselect:
            self.SelectCommunicationLink.setGeometry(QRect(520,125,28,28))
        else:
            self.SelectCommunicationLink.setGeometry(QRect(560,125,28,28))
        self.SelectCommunicationLink.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectCommunicationLink.setTextLabel("Select Element")
        self.setName("Stimulus")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.SenderEdit.setReadOnly(True)
        self.connect(self.newSender,SIGNAL('clicked()'),self.newSenderClicked)
        self.connect(self.selectSender,SIGNAL('clicked()'),self.selectSenderClicked)
        self.fieldTarget = None
        self.ReceiverEdit.setReadOnly(True)
        self.connect(self.NewReceiver,SIGNAL('clicked()'),self.NewReceiverClicked)
        self.connect(self.SelectReceiver,SIGNAL('clicked()'),self.SelectReceiverClicked)
        self.fieldTarget = None
        self.DispatchActionEdit.setReadOnly(True)
        self.connect(self.NewDispatchAction,SIGNAL('clicked()'),self.NewDispatchActionClicked)
        self.connect(self.SelectDispatchAction,SIGNAL('clicked()'),self.SelectDispatchActionClicked)
        self.fieldTarget = None
        self.CommunicationLinkEdit.setReadOnly(True)
        self.connect(self.NewCommunicationLink,SIGNAL('clicked()'),self.NewCommunicationLinkClicked)
        self.connect(self.SelectCommunicationLink,SIGNAL('clicked()'),self.SelectCommunicationLinkClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.Stimulus]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.sender
        self.fieldTarget=element.receiver
        self.fieldTarget=element.dispatchAction
        self.fieldTarget=element.communicationLink
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.SenderEdit.setText("")
        if element.sender:
            self.SenderEdit.setText(getFQName(element.sender,1))
            self.SenderEdit.setEdited(0)
        
        self.ReceiverEdit.setText("")
        if element.receiver:
            self.ReceiverEdit.setText(getFQName(element.receiver,1))
            self.ReceiverEdit.setEdited(0)
        
        self.DispatchActionEdit.setText("")
        if element.dispatchAction:
            self.DispatchActionEdit.setText(getFQName(element.dispatchAction,1))
            self.DispatchActionEdit.setEdited(0)
        
        self.CommunicationLinkEdit.setText("")
        if element.communicationLink:
            self.CommunicationLinkEdit.setText(getFQName(element.communicationLink,1))
            self.CommunicationLinkEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
            
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def selectSenderClicked(self):
        ed=self.focus.__type__().getPropertyByName("sender").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.sender=r
            self.SenderEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def newSenderClicked(self):
        prop=self.focus.__type__().getPropertyByName("sender")
        candidates = coral.inheritanceTree(prop.getTarget())
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
            newType=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.sender = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectReceiverClicked(self):
        ed=self.focus.__type__().getPropertyByName("receiver").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.receiver=r
            self.ReceiverEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewReceiverClicked(self):
        prop=self.focus.__type__().getPropertyByName("receiver")
        candidates = coral.inheritanceTree(prop.getTarget())
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
            newType=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.receiver = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectDispatchActionClicked(self):
        ed=self.focus.__type__().getPropertyByName("dispatchAction").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.dispatchAction=r
            self.DispatchActionEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewDispatchActionClicked(self):
        prop=self.focus.__type__().getPropertyByName("dispatchAction")
        candidates = coral.inheritanceTree(prop.getTarget())
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
            newType=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.dispatchAction = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def SelectCommunicationLinkClicked(self):
        ed=self.focus.__type__().getPropertyByName("communicationLink").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.communicationLink=r
            self.CommunicationLinkEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewCommunicationLinkClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            prop=self.focus.__type__().getPropertyByName("communicationLink")
            candidates = coral.inheritanceTree(prop.getTarget())
            sorted_candidates = [i for i in candidates ]
            sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
            dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
            if dlg.exec_loop():
             newLink=sorted_candidates[dlg.ComboBox1.currentItem()]
            else:
             newLink=None
             return
            if newLink:
             o=newLink()
             setattr(o,"name","(noname)")
            
            package=self.focus.sender
            package.ownedLink.append(o)
            self.focus.communicationLink=o
            self.CommunicationLinkEdit.setText(getFQName(o,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class ObjectEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Object")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("Object")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Object]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class StimuliEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Stimuli"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Link]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [StimulusEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "stimulus_at_Link"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.stimulus_at_Link,'stimulus')
        st=L.Stimulus(name=name)
        if len(focus.connection) == 2:
         if focus.connection[0].instance:
          st.sender = focus.connection[0].instance
         if focus.connection[1].instance:
          st.receiver = focus.connection[1].instance
        owner=focus.owner_at_Link.namespace
        owner.ownedElement.append(st)
        return st
        
    elementFactory = staticmethod(elementFactory)


class CollaborationEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Collaboration")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("Collaboration")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Collaboration]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class InteractionsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Interactions"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Collaboration]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [InteractionEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "interaction"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.interaction,'interaction')
        return L.Interaction(name=name)
    elementFactory = staticmethod(elementFactory)


class InteractionEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Interaction")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("Interaction")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Interaction]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class InteractionInstanceSetEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("InteractionInstanceSet")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("InteractionInstanceSet")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.InteractionInstanceSet]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class InteractionInstanceSetsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "InteractionInstanceSets"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.CollaborationInstanceSet]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [InteractionInstanceSetEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "interactionInstanceSet"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.interactionInstanceSet,'IIS')
        return L.InteractionInstanceSet(name=name)
    elementFactory = staticmethod(elementFactory)


class CollaborationInstanceSetEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("CollaborationInstanceSet")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"collaborationLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("collaboration:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.CollaborationEdit=ReferenceLineEdit(self,"CollaborationEdit")
        self.CollaborationEdit.setGeometry(QRect(240,30,200,20))
        noselect = False
        self.NewCollaboration=QToolButton(self,"NewCollaboration")
        self.NewCollaboration.setGeometry(QRect(450,25,28,28))
        self.NewCollaboration.setPixmap(iconcache.getIcon("newAction"))
        self.NewCollaboration.setTextLabel("New Element")
        self.SelectCollaboration=QToolButton(self,"SelectCollaboration")
        if noselect:
            self.SelectCollaboration.setGeometry(QRect(450,25,28,28))
        else:
            self.SelectCollaboration.setGeometry(QRect(490,25,28,28))
        self.SelectCollaboration.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectCollaboration.setTextLabel("Select Element")
        self.setName("CollaborationInstanceSet")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.CollaborationEdit.setReadOnly(True)
        self.connect(self.NewCollaboration,SIGNAL('clicked()'),self.NewCollaborationClicked)
        self.connect(self.SelectCollaboration,SIGNAL('clicked()'),self.SelectCollaborationClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.CollaborationInstanceSet]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.collaboration
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.CollaborationEdit.setText("")
        if element.collaboration:
            self.CollaborationEdit.setText(getFQName(element.collaboration,1))
            self.CollaborationEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectCollaborationClicked(self):
        ed=self.focus.__type__().getPropertyByName("collaboration").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.collaboration=r
            self.CollaborationEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewCollaborationClicked(self):
        newType = coral.lang.UML14.Collaboration
        coral.getTransactionManager().beginModifyCmd()
        try:
            newElement = newType()
            parent = coral.Element__getParentOfType__(self.focus, coral.lang.UML14.Namespace)
            parent.ownedElement.add(newElement)
            self.focus.collaboration = newElement
        finally:
            coral.getTransactionManager().endModifyCmd()
            
