# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.XMIDI20
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache


class DiagramEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Diagram")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(40,30,200,20))
        self.setName("Diagram")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Diagram]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class DiagramElementEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("DiagramElement")
        self.Label1= QLabel(self,"isVisibleLabel")
        self.Label1.setGeometry(QRect(40,10,200,20))
        self.Label1.setText("isVisible:")
        self.IsVisibleEdit=QCheckBox(self,"IsVisibleEdit")
        self.IsVisibleEdit.setGeometry(QRect(40,30,200,20))
        self.IsVisibleEdit.setText("isVisible")
        self.setName("DiagramElement")
        self.connect(self.IsVisibleEdit,SIGNAL('clicked()'),self.changed)
        self.connect(self.IsVisibleEdit,SIGNAL('clicked()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.DiagramElement]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.IsVisibleEdit.setChecked(element.isVisible)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            self.focus.isVisible=self.IsVisibleEdit.isChecked()
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class ContainedEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Contained"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.GraphElement]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def getSubEditors():
        return [DiagramElementEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "contained"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        return None
        
    elementFactory = staticmethod(elementFactory)

