# -*- coding: UTF-8 -*-
# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

# WARNING! This file is generated! All changes made in this file will be lost!

import coral
from coral.modeler.extension import PropertyEditor
from coral.modeler.property.propertyeditor import CompositePropertyEditor,AssociationListE,NewElementDlg
from coral.modeler.NameFactory import *
from qt import *
import string
from coral.modeler.getFQName import getFQName
L=coral.lang.CONSTRAINT10
from coral.modeler.outline.outlineeditor import ElementPick
from coral.modeler import iconcache


class ResultsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Results"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.ConstraintModel]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def filterAssociation(e):
        if e.oclIsKindOf(L.Result):
            return 1
        return 0
    filterAssociation = staticmethod(filterAssociation)

    def getSubEditors():
        return [ResultEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "result"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.result,'Result')
        
        
        return L.Result(name=name)
        
        
    elementFactory = staticmethod(elementFactory)


class ResultEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("Result")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"messageLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("message:")
        self.MessageEdit=QTextEdit(self,"MessageEdit")
        self.MessageEdit.setGeometry(QRect(240,30,300,200))
        self.setName("Result")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.MessageEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.MessageEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.Result]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.MessageEdit.getCursorPosition()
        self.MessageEdit.setText(unicode(element.message))
        self.MessageEdit.setCursorPosition(line,index)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.MessageEdit.text())
            self.focus.message=t
            
        finally:
            coral.getTransactionManager().endModifyCmd()


class ConstraintsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "Constraints"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Package]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def filterAssociation(e):
        if e.oclIsKindOf(L.Constraint):
            return 1
        return 0
    filterAssociation = staticmethod(filterAssociation)

    def getSubEditors():
        return [PythonConstraintEditor,QueryScriptConstraintEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "element"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        candidates = coral.inheritanceTree(L.Constraint)
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
         newClass=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
         newClass=None
         return
                
        if newClass:
         o=newClass()
         setattr(o,"name","(noname)")
         focus.element.append(o)
         return o
    elementFactory = staticmethod(elementFactory)


class ConstraintModelEditor(PropertyEditor,QWidget):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QWidget.__init__(self,parent)
        self.setCaption("ConstraintModel")
        self.Label1= QLabel(self,"nameLabel")
        self.Label1.setGeometry(QRect(20,10,200,20))
        self.Label1.setText("name:")
        self.NameEdit=QLineEdit(self,"NameEdit")
        self.NameEdit.setGeometry(QRect(20,30,200,20))
        self.Label2= QLabel(self,"targetLabel")
        self.Label2.setGeometry(QRect(240,10,200,20))
        self.Label2.setText("target:")
        from coral.modeler.property.propertyeditor import ReferenceLineEdit
        self.TargetEdit=ReferenceLineEdit(self,"TargetEdit")
        self.TargetEdit.setGeometry(QRect(240,30,200,20))
        noselect = False
        self.NewTarget=QToolButton(self,"NewTarget")
        self.NewTarget.setGeometry(QRect(450,25,28,28))
        self.NewTarget.setPixmap(iconcache.getIcon("newAction"))
        self.NewTarget.setTextLabel("New Element")
        self.SelectTarget=QToolButton(self,"SelectTarget")
        if noselect:
            self.SelectTarget.setGeometry(QRect(450,25,28,28))
        else:
            self.SelectTarget.setGeometry(QRect(490,25,28,28))
        self.SelectTarget.setPixmap(iconcache.getIcon("linkAction"))
        self.SelectTarget.setTextLabel("Select Element")
        self.setName("ConstraintModel")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.TargetEdit.setReadOnly(True)
        self.connect(self.NewTarget,SIGNAL('clicked()'),self.NewTargetClicked)
        self.connect(self.SelectTarget,SIGNAL('clicked()'),self.SelectTargetClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QWidget.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.ConstraintModel]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.target
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        self.TargetEdit.setText("")
        if element.target:
            self.TargetEdit.setText(getFQName(element.target,1))
            self.TargetEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def SelectTargetClicked(self):
        ed=self.focus.__type__().getPropertyByName("target").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.target=r
            self.TargetEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def NewTargetClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            pass
        finally:
            coral.getTransactionManager().endModifyCmd()
            

class ConstraintModelsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "ConstraintModels"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.Package]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def filterAssociation(e):
        if e.oclIsKindOf(L.ConstraintModel):
            return 1
        return 0
    filterAssociation = staticmethod(filterAssociation)

    def getSubEditors():
        return [ConstraintModelEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "element"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        name=createUniqueName(focus.element,'ConstraintModel')
        return L.ConstraintModel(name=name)
        
        
    elementFactory = staticmethod(elementFactory)


class BindConstraintsEditor(CompositePropertyEditor):

    def __init__(self, editorSet, parent, manager):
        CompositePropertyEditor.__init__(self, editorSet, parent, manager)
        
    def getName():
        return "BindConstraints"

    getName = staticmethod(getName)
    def canEdit(e):
        for element in [L.ConstraintModel]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def filterAssociation(e):
        if e.oclIsKindOf(L.Element):
            return 1
        return 0
    filterAssociation = staticmethod(filterAssociation)

    def getSubEditors():
        return [PythonConstraintEditor,QueryScriptConstraintEditor,]

    getSubEditors = staticmethod(getSubEditors)
    def getAssociationName():
        return "constraint"

    getAssociationName = staticmethod(getAssociationName)
    def elementFactory(focus):
        candidates=coral.inheritanceTree(L.Constraint)
        sorted_candidates = [i for i in candidates ]
        sorted_candidates.sort(lambda x,y: cmp(x.getName(), y.getName()))
        dlg=NewElementDlg(candidates=sorted_candidates,modal=1)
        if dlg.exec_loop():
         newClass=sorted_candidates[dlg.ComboBox1.currentItem()]
        else:
         newClass=None
         return
                
        if newClass:
         o=newClass()
         setattr(o,"name","(noname)")
         if self.focus.__parent__(): 
          self.focus.__parent__().element.append(o)
         else:
          o.__setProject__(self.focus.__getRootsProject__())
         return o
        
    elementFactory = staticmethod(elementFactory)

from coral.addins.constraint.PythonConstraintPE import PythonConstraintPE

class PythonConstraintEditor(PythonConstraintPE,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        PythonConstraintPE.__init__(self,parent)
        self.setName("PythonConstraint")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.DescriptionEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('returnPressed()'),self.apply)
        self.TargetEdit.setReadOnly(True)
        self.connect(self.dummyButton,SIGNAL('clicked()'),self.dummyButtonClicked)
        self.connect(self.pickED,SIGNAL('clicked()'),self.pickEDClicked)
        self.fieldTarget = None
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        PythonConstraintPE.close(self, alsoDelete)
    
    def doubleClicked(self):
        if self.fieldTarget:
            self.notifyFocusOn(self.fieldTarget)

    def canEdit(e):
        for element in [L.PythonConstraint]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        self.fieldTarget=element.kind
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.ScriptEdit.getCursorPosition()
        self.ScriptEdit.setText(unicode(element.script))
        self.ScriptEdit.setCursorPosition(line,index)
        
        line,index=self.DescriptionEdit.getCursorPosition()
        self.DescriptionEdit.setText(unicode(element.description))
        self.DescriptionEdit.setCursorPosition(line,index)
        
        self.TargetEdit.setText("")
        if element.kind:
            self.TargetEdit.setText(getFQName(element.kind,1))
            self.TargetEdit.setEdited(0)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.ScriptEdit.text())
            self.focus.script=t
            
            t=unicode(self.DescriptionEdit.text())
            self.focus.description=t
            
            
        finally:
            coral.getTransactionManager().endModifyCmd()

    def pickEDClicked(self):
        ed=self.focus.__type__().getPropertyByName("kind").getTarget()
        r=ElementPick(self.editorSet).pick(self.focus, ed)
        if not r:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.focus.kind=r
            self.TargetEdit.setText(getFQName(r,1))
        finally:
            coral.getTransactionManager().endModifyCmd()
            
    def dummyButtonClicked(self):
        coral.getTransactionManager().beginModifyCmd()
        try:
            pass
            
        finally:
            coral.getTransactionManager().endModifyCmd()
            
from coral.addins.constraint.QueryScriptConstraintPE import QueryScriptConstraintPE

class QueryScriptConstraintEditor(QueryScriptConstraintPE,PropertyEditor):

    def __init__(self, editorSet, parent, manager):
        PropertyEditor.__init__(self, editorSet, parent, manager)
        QueryScriptConstraintPE.__init__(self,parent)
        self.setName("QueryScriptConstraint")
        self.connect(self.NameEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.NameEdit,SIGNAL('textChanged(const QString &)'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.ScriptEdit,SIGNAL('returnPressed()'),self.apply)
        self.connect(self.DescriptionEdit,SIGNAL('textChanged()'),self.changed)
        self.connect(self.DescriptionEdit,SIGNAL('returnPressed()'),self.apply)
        
    def close(self, alsoDelete):
        PropertyEditor.finalize(self)
        QueryScriptConstraintPE.close(self, alsoDelete)
    
    def canEdit(e):
        for element in [L.QueryScriptConstraint]:
            if e.oclIsKindOf(element):
                return 1
        return 0
    canEdit = staticmethod(canEdit)

    def focusOn(self,element):
        self.setEdited(0)
        if not element:
            return
        PropertyEditor.focusOn(self,element)
        self.NameEdit.setText(unicode(element.name))
        self.NameEdit.setEdited(0)
        
        line,index=self.ScriptEdit.getCursorPosition()
        self.ScriptEdit.setText(unicode(element.script))
        self.ScriptEdit.setCursorPosition(line,index)
        
        line,index=self.DescriptionEdit.getCursorPosition()
        self.DescriptionEdit.setText(unicode(element.description))
        self.DescriptionEdit.setCursorPosition(line,index)
        
    def apply(self):
        if not self.edited:
            return
        coral.getTransactionManager().beginModifyCmd()
        try:
            self.setEdited(0)
            t=unicode(self.NameEdit.text())
            self.focus.name=t
            self.NameEdit.setEdited(0)
            
            t=unicode(self.ScriptEdit.text())
            self.focus.script=t
            
            t=unicode(self.DescriptionEdit.text())
            self.focus.description=t
            
        finally:
            coral.getTransactionManager().endModifyCmd()

