# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

import qt
import coral
from coral.modeler.dlg.LanguageSelectionDlg import LanguageSelectionDlg

class LanguageSelectionDlgEx(LanguageSelectionDlg):

    def main(self,languages,modal=1):
        
        self.languages=languages
        self._lang = []
        for l in languages:
            # metaclass(l) = coral.lang.CoralEx10.LanguageDescription
            self.languageList.insertItem(l.name+" "+str(l.version)+"."+str(l.revision))
            self._lang.append(l)

        if modal:
            self.exec_loop()
            if self.result()==qt.QDialog.Rejected:
                return -1
            else:
                return self.languageList.currentItem()
        else:
            self.show()
            return -1

    def describe(self,a0):
        langdesc = self._lang[self.languageList.currentItem()]

        doc = []

        try:
            L = coral.Language.__getLanguageByXMLNS__(langdesc.URInamespace, False)
            L = L.getCorrespondingElement()
            for d in L.documentation:
                for txt in d.text:
                    txt = unicode(txt)
                    doc += txt
                    if txt and txt[-1].isspace():
                        pass
                    else:
                        doc += "\n"
        except:
            doc.append("The " + langdesc.name + " " + unicode(langdesc.version) + "." + unicode(langdesc.revision) + " language.")
            doc.append("\n")
            doc.append("Unfortunately no more information is available of this language.")
            
        self.description.setText("".join(doc))
