import coral

def get_all_parts(set):
    all_parts=coral.Set()
    for elem in set:
        all_parts.unionWith(elem.__getAllParts__())
    return all_parts

def isKindOf(qelem, telem):
    return telem.oclIsKindOf(qelem.__type__())

def isSameType(qelem, telem):
    return telem.__type__() == qelem.__type__()

def isPermutationOfItSelf(match_data):
    # Calculate the symmetry of the query
    # If the query matches it-self only one time then we don't
    # need to filter permutations
    matches=0
    for start in match_data.query_set:
        matches += len(search(query_set, start, query_set[0], True, TwoMatchState))
        if matches>1:
            break

    return matches > 1

class Results:
    def __init__(self, allow_permutations=False):
        self.results=[]
        self.sorted_results=[]
        
        if allow_permutations:
            self.append=self.append_perm
        else:
            self.append=self.append_unique
        
    def append_unique(self, result):
        target_list=result.values()
        target_list.sort()
        if target_list in self.sorted_results:
            return 0

        self.sorted_results.append(target_list)
        self.results.append(result)
        return 1
    
    def append_perm(self, result):
        self.results.append(result)
        
    def getList(self):
        return self.results
